menu block MAP_CALC delete
menu block MAP_CALC create
menu block MAP_CALC color 160
menu block MAP_CALC document >doc/menu/map_calc.txt

menu block MAP_CALC item BULK_SOL add -
       text "< ?MAIN_CMDS:calc_bulk_solv_corr.cmds"
set vari BULK_SOLVE global = OFF
menu block MAP_CALC item BULK_SOL button off
menu block MAP_CALC item ANISO_B add -
       text "< ?MAIN_CMDS:calc_aniso_coor.cmds"
set vari ANISO_CORR global = OFF
menu block MAP_CALC item ANISO_B  button off
menu block MAP_CALC item ML_MAP add -
       text "< ?MAIN_CMDS:calc_sigma_a_map.cmds"
set vari SIGMAA_MAP char global = OFF
menu block MAP_CALC item ML_MAP  button off

menu block MAP_CALC item RE_PHASE add -
       text "< ?MAIN_CMDS:re_phase.cmds WORK_SEGM MAP_WORK"
menu block MAP_CALC item PHAS_CMB add -
       text "< ?MAIN_CMDS:phase_comb.cmds WORK_SEGM MAP_2FOFC"
menu block MAP_CALC item FOBS_MAP add -
       text "< ?MAIN_CMDS:calc_fo_map.cmds MAP_FO"

menu block MAP_CALC item FO-FC_MA add -
       text "< ?MAIN_CMDS:calc_fofc_diff_map.cmds MAP_FOFC 1. 1."
menu block MAP_CALC item 2FO-FC_M add -
       text "< ?MAIN_CMDS:calc_fofc_diff_map.cmds MAP_2FOFC 2. 1."



menu block MAP_CALC item KICK_0.3 add \
     text "<>cmds/map_calc_kick_stuf_field.cmds 3"
menu block MAP_CALC item KICK_?? \
     add text "<>cmds/map_calc_kick_stuf_field.cmds 5"
menu block MAP_CALC item KICK_SEED \
     add text "<>cmds/map_calc_kick_stuf_field.cmds 6"

set vari KICK_VAL real global = 0.3

menu block MAP_CALC item KICK_0.3 button on
menu block MAP_CALC item KICK_??  button off

set vari KICK_ADDS int global = 1

menu block MAP_CALC item MAP_+_?? \
     add text "<>cmds/kick_add_maps.cmds"
menu block  MAP_CALC item OMIT_MAP add text \
 "<?MAIN_CMDS:calc_kick_omit_map.cmds WORK_SEGM KICK_VAL MAP_FOFC KICK_ADDS"
menu block  MAP_CALC item KICK_MAP add text \
 "<?MAIN_CMDS:calc_kick_map.cmds WORK_SEGM KICK_VAL MAP_2FOFC KICK_ADDS"
menu page 10 add MAP_CALC

return

menu block MAP_CALC item REF_DENS add - 
       text "< ?MAIN_CMDS:refine_target.cmds REF_DENS"
menu block MAP_CALC item  REF_DIFF add - 
       text "< ?MAIN_CMDS:refine_target.cmds REF_DIFF"
menu block MAP_CALC item REF_XLSQ add - 
       text "< ?MAIN_CMDS:refine_target.cmds REF_XLSQ"



set vari REF_METHOD char global = "REF_DIFF"
menu block MAP_CALC item REF_DIFF button on
menu block MAP_CALC item REF_DENS button off
menu block MAP_CALC item REF_XLSQ button off

menu block MAP_CALC item KICK_ALL \
     add text "set coor  sele segm name WORK_SEGM end kick KICK_VAL"
menu block MAP_CALC item REFINE add - 
       text "< ?MAIN_CMDS:refine.cmds WORK_SEGM MAP_WORK"
menu block MAP_CALC item REFINE_B add - 
       text "< ?MAIN_CMDS:refine_b.cmds WORK_SEGM MAP_WORK"

menu block MAP_CALC item GEN_SOLV add - 
	text "< ?MAIN_CMDS:gen_solvent.cmds"

return


menu block MAP_CALC item MAP_ACT? add text "<>cmds/make_map_active.cmds"
menu block MAP_CALC item MAP_PAS? add text "<>cmds/make_map_from.cmds"
menu block MAP_CALC item MAP_AROU add text "<>cmds/make_map_around.cmds"
menu block MAP_CALC item ATO_RAD? add text "<>cmds/make_map_radius.cmds"
menu block MAP_CALC item ATO_MASK add text -
  "make map MAP_ACT atom mask map_rad select active end"
menu block MAP_CALC item ATO_CLEA add text -
  "make map MAP_ACT atom clea map_rad select active end"
menu block MAP_CALC item ATO_DENS add text -
  "make map MAP_ACT atom dens select active end"
menu block MAP_CALC item ATO_DIFF add text "<>cmds/make_MAP_CALC_diff.cmds"
