menu block ANALYSIS delete
menu block ANALYSIS create
menu block ANALYSIS color 220
menu block ANALYSIS document >doc/menu/analysis.txt


menu block ANALYSIS item GRP_RESI \
      add text "<?MAIN_CMDS:anal_group.cmds RESIDUE"
menu block ANALYSIS item GRP_ATOM \
      add text "<?MAIN_CMDS:anal_group.cmds ATOM"
set vari ANAL_GRP char glob = ATOM
menu block ANALYSIS item GRP_RESI button off
menu block ANALYSIS item GRP_ATOM  button on
set vari NEXT_RESI int global = 1

menu block ANALYSIS item ANA_TEMP \
     add text "<?MAIN_CMDS:anal_temp.cmds WORK_SEGM ANAL_GRP"

menu block ANALYSIS item BY_FORCE \
      add text "<?MAIN_CMDS:anal_kind.cmds FORCE"
menu block ANALYSIS item BY_ENERG \
      add text "<?MAIN_CMDS:anal_kind.cmds ENERGY"
set vari ANAL_KIND char glob = FORCE
menu block ANALYSIS item BY_FORCE button on
menu block ANALYSIS item BY_ENERG button off

menu block ANALYSIS item ANA_ENER \
      add text "<?MAIN_CMDS:anal_ener.cmds WORK_SEGM ANAL_GRP ANAL_KIND"

!menu block ANALYSIS item 2D_TEMP \
!      add text "<?MAIN_CMDS:anal_graph_temp.cmds WORK_SEGM"
!menu block ANALYSIS item ANA_IMAG \
!      add text "<?MAIN_CMDS:anal_3d_image.cmds WORK_SEGM ANAL_GRP"

menu block ANALYSIS item GEN_LIST \
      add text "<?MAIN_CMDS_NEW:anal_center_list.cmds WORK_SEGM"
menu block ANALYSIS item GEN_LIST \
     configure "tk_config.pl MY_TK_CONF -m create_anal_center.pl &"

menu block ANALYSIS item ANA_BOND \
      add text "<?MAIN_CMDS:anal_param_bond.cmds WORK_SEGM"
menu block ANALYSIS item ANA_ANGL \
      add text "<?MAIN_CMDS:anal_param_angle.cmds WORK_SEGM"
menu block ANALYSIS item TEM_GROU \
      add text "show temp sele active .a weigh 0.01 1.01 end"
menu block ANALYSIS item TEM_BOND \
      add text "show temp bond sele active .a weigh 0.01 1.01 end"

menu block ANALYSIS item XML_VALI \
      add text "<?MAIN_CMDS_NEW:validation_PDB_list.cmds WORK_SEGM"
menu block ANALYSIS item XML_VALI \
     configure "tk_config.pl MY_TK_CONF -m create_validation_PDB_list.pl &"

menu page 8 add ANALYSIS
return


menu block ANALYSIS item R-REAL \
      add text "<?MAIN_CMDS:anal_r-real.cmds WORK_SEGM MAP_2FOFC MAP_FOFC"
menu block ANALYSIS item C-REAL \
      add text "<?MAIN_CMDS:anal_c-real.cmds WORK_SEGM MAP_2FOFC MAP_FOFC"
menu block ANALYSIS item R-ACT_OM add text \
   "<?MAIN_CMDS:anal_r-omit_active.cmds WORK_SEGM KICK_VAL MAP_2FOFC MAP_FOFC"
menu block ANALYSIS item R-OMIT add text \
   "<?MAIN_CMDS:anal_r-omit.cmds WORK_SEGM KICK_VAL MAP_2FOFC MAP_FOFC"
menu block ANALYSIS item C-ACT_OM add text \
   "<?MAIN_CMDS:anal_c-omit_active.cmds WORK_SEGM KICK_VAL MAP_2FOFC MAP_FOFC"
menu block ANALYSIS item C-OMIT add text \
   "<?MAIN_CMDS:anal_c-omit.cmds WORK_SEGM KICK_VAL MAP_2FOFC MAP_FOFC"

menu block ANALYSIS item GRAP_RVA \
      add text "<?MAIN_CMDS:anal_graph_rval.cmds WORK_SEGM"
menu block ANALYSIS item GRAP_COR \
      add text "<?MAIN_CMDS:anal_graph_correl.cmds WORK_SEGM"

