<get_data_hex

read file FILE_CELL cell
read file FILE_SYMM symm
read file FILE_REFL reflect init resol 3.3 100. limit 0 0 0 friedel
read file FILE_ATOM atom pdb
set weight sele atom name H* end 0.0
!set temp sele all end 30.0
key KEY_MASK sele all end
!key KEY_MASK sele .not seq B113 B117 end

set vari MAP_CELL = 1
set vari MAP_MASK = 2
set vari HOLE_SIZE = 8
set vari ATOM_RAD = 3.5
set vari GRID_ARO = 10

make map MAP_CELL from 0 init -9999 grid  80 80 162 cell real

make map MAP_MASK from MAP_CELL init -9999  \
     around GRID_ARO sele KEY_MASK end  real

make map MAP_MASK atom mask ATOM_RAD select KEY_MASK end

! fill the holes in envelope that have HOLE_SIZE grid points in diameter

make map MAP_MASK + 1 from MAP_MASK init 9999 copy
make map MAP_MASK from MAP_MASK + 1 fill HOLE_SIZE

symm sele all end around sele all end dist 6. cut

make map MAP_MASK set 9000 100000 100.
make map MAP_MASK atom mask ATOM_RAD / 2.  sele segm name #* end
make map MAP_MASK set 9000 100000 -9999.
make map MAP_MASK set 0 1000 9999.
write over file FILE_MASK map MAP_MASK xplor

make map MAP_CELL zero
make map MAP_CELL set -1 1 -9999.
make map MAP_CELL atom dens \
                  atom symm select segm name CB_* end
make map MAP_CELL rescale
<calc_a_map
write over file FILE_MAP map MAP_CELL xplor

return





