#!/usr/bin/perl -w


use strict;
use lib $ENV{ 'MAIN_CONF'}  ;
use main_config ;

my @lines ;

my $file_name = "bulk_solvent.log" ;
open ( TXT, $file_name ) || die "FILE OPEN ERROR: >$file_name< \n" ; 

my $np_line ;
my $line ;
my $scatr ;

while(<TXT>)
{
    chomp ;
    $line = $_ ;
    $np_line++ ;
    push ( @lines, $line );
}
close ( TXT ) ;

my $key ;
$key = "----" ;
my $values ;
my %scat_factors ;
my %factors_list ;
my @factors = () ;
my @words ;
$values = "&" ;
$key = "NONE " ;

my $rfact ; my $test_val = 0.15 ;
foreach $line ( @lines )
{
    $scatr = substr( $line, 0,13 ) ;
    if ( $scatr eq "==========+++" ) { $values = substr( $line, 31,26 ) }
    $scatr = substr( $line, 16,13 ) ;  # print " rfact line = {$scatr} \n" ;
    

    if ( $scatr eq "  1.800  1145" ) # ferredoxin
#    if ( $scatr eq "  2.600   983" ) # amdl
    { 
	$key = substr( $line, 65,6 ) ;  
	#	$rfact = $key ;
#	print " key = {$key} \n" ; 
	if ( $key <= 0.15 ) { print $key, " values:", $values, "\n" ; }
	push(@{$factors_list{$key}}, $values ) ;
    }
}
my $nn = 0 ; my @key_list ;
foreach $key ( keys %factors_list ) 
{ 
    push(@key_list, $key ) ; 
    $nn++ ;
}

print " population of R-values: $nn\n" ;
my @sorted = sort { $a <=> $b } @key_list ;

#foreach $key ( sort keys (%factors_list) )
my $II ;
$II = 0 ;
foreach $key ( @sorted ) 
{
    $II++ ;
    if ( $II > 10 ) { last ; }
	print " -----    $II    ----\n" ;
    foreach $values ( @{$factors_list{$key}} )
    {
	print " $key === $values \n" ;
    }
}
