#!/usr/bin/perl -w
use strict;
use lib $ENV{ 'MAIN_CONF'}  ;
use main_config ;

my $INPUT_FILE ;
my $OUTPUT_FILE ;

while ( @ARGV != 0 ) 
{ 
$INPUT_FILE = pop(@ARGV ) ;
$OUTPUT_FILE = $INPUT_FILE . ".done" ;


my $line ; 
my @input_lines ;

open ( TXT,  "< $INPUT_FILE" ) || die "FILE OPEN ERROR: >< \n" ;
while ( <TXT> )
{
    $line = $_ ;
    chomp ($line ) ;
    push( @input_lines, $line )
}
close (TXT) ;

system ("mv $INPUT_FILE $OUTPUT_FILE" ) ;
print "modifying $INPUT_FILE - orig saving as $OUTPUT_FILE \n"  ;

my @words ;
my $I = 0 ;
my $nn = -1 ;
my $out_flag = 0 ;

open ( TXT,  "> $INPUT_FILE" ) || die "FILE OPEN OUT ERROR: >< \n" ;
while ($I< @input_lines   )
{
    $line = $input_lines[$I] ;
    if ( length($line) <= 0 ) { $I++ ; print TXT "\n" ; next ; }

    @words = split(" ", $line ) ;
#    print $I, ":", $line, "\n" ;
    if ( @words == 0 ) { $I++ ;  print TXT "\n" ; next ; }
    if ( $words[0] eq "C?VAX" ) { $I++ ; $out_flag = 1 ; next ; }
    if ( $words[0] eq "C?ESV" ) { $I++ ; $out_flag = 0 ; print TXT "\n" ; next ; }
    if ( $words[0] eq "C??" ) 
    { 
	if ( $out_flag == 0 ) { print TXT "\n" ; }
	$I++ ; 
	$out_flag = 0 ; 

	next ; 
    }
    if ( $out_flag == 1 ) { $I++ ; next ; }
    print TXT $line, "\n" ;
    $I++ ;
}
close (TXT) ;
}


