#!/usr/bin/python3
import os
import re
import sys
import gzip

def recursive_file_gen(mydir):
    print ( "recusrive file gen>", mydir )
    for p in mydir:
        for root, dirs, files in os.walk(p):
            for file in files:
                yield os.path.join(root, file)

def recursive_directory_gen(mydir):
    for root, dirs, files in os.walk(mydir):
        yield root

def get_commands():
    key = ""
    d = dict() 
#    d.clear()
    for arg in sys.argv:
        chars = list(arg)
#        for s in chars:
#            print( s )
#        if ( len (chars) <= 0 ):
#            continue
#        print ( len(chars))
        if ( chars[0] == '-' ):
#            print ( "1- line:%s", arg)
            if( chars[1] == '-' ):
                del chars[0]
                del chars[0]
                key = "".join(chars)
#                print ( "2- key:%s", key )
                d[key] = list ()
            else:
                del chars[0]
                key = "".join(chars)
                d[key] = list ()
#                print ( "1- key:%s", key )
        else:
            if ( key != "" ):
#                print ( "my key:%s -> line %s", key, arg)
                if ( key in d ):
                    d[key].append(arg)
#                    print (d[key])
                else:
                    d[key].append(arg)
#                    print ( key, d[key] )

#    for key, v in d.items():
#        print ( key, v )
    return d

def read_gzip_file(my_file):
#    f = gzip.open('file.txt.gz', 'rb')
    f = gzip.open( my_file, 'rb')
    file_content = f.read()
    f.close()
    return file_content

#            print ( file )

def read_file(my_file):
#    f = gzip.open('file.txt.gz', 'rb')
    file_content = list()
    f = open( my_file, 'r')
    for line in f:
        line.rstrip()
        if ( line[-1] == '\n' ):
            line = line[:-1]
        file_content.append(line)
    f.close()
    return file_content

def write_file(my_file, my_lines):

#    f = gzip.open('file.txt.gz', 'rb')
    file_content = list()

    if ( os.path.isfile(my_file) ):
        o_file = my_file + ".old"
        if ( os.path.isfile(o_file) ):
            o2_file = my_file + ".old2"
            jj = "mv " + o_file + " " + o2_file
            os.system( jj )
        jj = "mv " + my_file + " " + my_file + ".old"
        os.system( jj )
        print( " ----------------->", my_file )

    f = open( my_file, 'w')
    for line in my_lines:
        l = line + "\n"
        f.write( l )
    f.close()
    return file_content

#            print ( file )

def replace_in_line(my_file, my_line, my_replace):
    m_list = list()
    c_line = list( my_line )
#    print ()
#    print( " in>", my_line )
    for m in re.finditer(my_pattern, my_line):
        print(my_pattern, ' found', m.start(), m.end())
        i1 = int ( m.start() )
        i2 = int ( m.end() )

        #            print ( "i1 in i2:", i1, i2 )
            
        if ( i1 > 1 ):
            chr = c_line[i1-1]
            print ( "first chr:", chr, i1 )
            if ( ( chr >= "A" and chr <= "Z" ) or
                 ( chr >= "a" and chr <= "z" ) or
                 ( chr >= "0" and chr <= "9" ) or
                 chr == "_" or chr == "." or chr == "'" ):
                continue

        if ( i2 < len(my_line) ):
            chr = c_line[i2]
            print ( "after chr:", chr, i2 )
            if ( ( chr >= "A" and chr <= "Z" ) or
                 ( chr >= "a" and chr <= "z" ) or
                 ( chr >= "0" and chr <= "9" ) or
                 chr == "_" or chr == "'" or chr == "." ):
                continue
        print ( my_file, "to be replaced>", i1, i2, my_line )
#        m_list.append( i1 )

        m_list.append( [i1, i2] )

    for ii in reversed ( m_list ) :
        i1 = ii[0]
        i2 = ii[1]
        print( i1, i2, ">", c_line[i1:i2], "<=>", my_replace, "<" )
        c_line[i1:i2] = list(my_replace)
        

    out_line = "".join(c_line)

    return out_line



def swap_in_line(my_line, my_file):
#    f = gzip.open('file.txt.gz', 'rb')
    m_list = list()
    c_line = list( my_line )
#    print ()
#    print( " in>", my_line )
    for m in re.finditer(my_pattern, my_line):
        #         print(my_pattern, ' found', m.start(), m.end())
        i1 = int ( m.start() )
        i2 = int ( m.end() )
        if ( i2 >= len(c_line) ):
            continue
            #            print ( "i1 in i2:", i1, i2 )
            
        if ( c_line[i2] == " " ):
            i2 = i2 + 1
        if ( c_line[i2] == " " ):
            i2 = i2 + 1
        if ( c_line[i2] == " " ):
            i2 = i2 + 1
        if ( c_line[i2] != "(" ):
            #                print( my_pattern, cnt, ">", c_line[i2],"<", line )
            continue

        if ( i1 > 1 ):
            chr = c_line[i1-1]
            if ( ( chr >= "A" and chr <= "Z" ) or
                 ( chr >= "a" and chr <= "z" ) or
                 ( chr >= "0" and chr <= "9" ) or
                 chr == "_" ):
                continue

#        print ( "ict with braces", i1, i2 )
        
#        m_list.append( i1 )
        m_list.append( i2 )

    m_break = -1
    for i2 in reversed(m_list):
        m_brace = "DO"
        m = i2
        m_lev = 1
        i3 = -1
        while ( m < len(c_line)-1 ):
            m = m + 1
            if ( m_lev == 1 and c_line[m] == "," ):
                m_break = m
                #print (" break found", m_break, ">", c_line[m], "<" )
                # m_lev = m_lev + 1
            if ( c_line[m] == "(" ):
                m_lev = m_lev + 1
            if ( c_line[m] == ")" ):
                m_lev = m_lev - 1
            #print( "m>", c_line[m], "< level", m_lev )
            if ( m_lev == 0 ):
                i3 = m 
                m_brace = "DONE"
                break
        
        if ( m_brace == "DONE" and m_break > i2 ):
            string = "".join(c_line[i2-3:i3+1])
            str1 = "".join(c_line[i2+1:m_break])
            str2 = "".join(c_line[m_break+1: i3])
            #print (" m_break:", i2, m_break, i3 )
            new_string = str2 + "," + str1
            # print (" strings:", str1, "|", str2 )
            #print ( "to be switched> ", string, " for >", new_string, "<" )
            n_list = list(new_string)
            c_line[i2+1:i3] = n_list[:]

        else:
            print ( my_file, ">", m_brace, m_break, m_lev, "-> closure not found", i1, i2, my_line )

    out_line = "".join(c_line)
#    print( "out>", out_line, "<" )

    return out_line

def swap4_in_line(my_line, my_file):
#    f = gzip.open('file.txt.gz', 'rb')
    m_list = list()
    c_line = list( my_line )
#    print ()
#    print( " in>", my_line )
    for m in re.finditer(my_pattern, my_line):
        #print(my_pattern, ' found', m.start(), m.end())
        i1 = int ( m.start() )
        i2 = int ( m.end() )
        if ( i2 >= len(c_line) ):
            continue
            #            print ( "i1 in i2:", i1, i2 )
            
        if ( c_line[i2] == " " ):
            i2 = i2 + 1
        if ( c_line[i2] == " " ):
            i2 = i2 + 1
        if ( c_line[i2] == " " ):
            i2 = i2 + 1
        if ( c_line[i2] != "(" ):
            #print( my_pattern, cnt, ">", c_line[i2],"<", line )
            continue

        if ( i1 > 1 ):
            chr = c_line[i1-1]
            if ( ( chr >= "A" and chr <= "Z" ) or
                 ( chr >= "a" and chr <= "z" ) or
                 ( chr >= "0" and chr <= "9" ) or
                 chr == "_" ):
                continue

        #print ( "atcons with braces", i1, i2 )
        
#        m_list.append( i1 )
        m_list.append( i2 )

    m_break = -1
    for i2 in reversed(m_list):
        m_brace = "DO"
        mm = 0
        m = i2
        m_lev = 1
        i3 = -1
        while ( m < len(c_line)-1 ):
            m = m + 1
            if ( m_lev == 1 and c_line[m] == "," ):
                if ( mm == 2 ):
                    continue
                mm = mm + 1
                m_break = m
                #print (mm, " 2nd break found", m_break, ">", c_line[m], "<" )
                # m_lev = m_lev + 1
            if ( c_line[m] == "(" ):
                m_lev = m_lev + 1
            if ( c_line[m] == ")" ):
                m_lev = m_lev - 1
            #print( "m>", c_line[m], "< level", m_lev )
            if ( m_lev == 0 and mm == 2 ):
                i3 = m 
                m_brace = "DONE"
                #print ( "m_brace done", m, mm, m_brace )
                break
        
        if ( m_brace == "DONE" and m_break > i2 ):
            string = "".join(c_line[i2-6:i3+1])
            str1 = "".join(c_line[i2+1:m_break])
            str2 = "".join(c_line[m_break+1: i3])
            #print (" m_break:", i2, m_break, i3 )
            new_string = str2 + "," + str1
            #print (" strings:", str1, "|", str2 )
            #print ( "to be switched> ", string, " for >", new_string, "<" )
            n_list = list(new_string)
            c_line[i2+1:i3] = n_list[:]

        else:
            print ( my_file, ">", m_brace, m_break, m_lev, "-> closure4 not found", i1, i2, my_line )

    out_line = "".join(c_line)
#    print( "out>", out_line, "<" )

    return out_line




############################################################
#
#      wrap a variable in an array 
#
###########################################################

def wrap_in_line(my_file, my_line, my_wrap):
    m_list = list()
    c_line = list( my_line )
#    print ()
#    print( " in>", my_line )
    for m in re.finditer(my_pattern, my_line):
        print(my_pattern, ' found', m.start(), m.end())
        i1 = int ( m.start() )
        i2 = int ( m.end() )

        #            print ( "i1 in i2:", i1, i2 )
            
        if ( i1 > 1 ):
            chr = c_line[i1-1]
            print ( "first chr:", chr, i1 )
            if ( ( chr >= "A" and chr <= "Z" ) or
                 ( chr >= "a" and chr <= "z" ) or
                 ( chr >= "0" and chr <= "9" ) or
                 chr == "_" or chr == "." or chr == "'" ):
                continue

        if ( i2 < len(my_line) ):
            chr = c_line[i2]
            print ( "after chr:", chr, i2 )
            if ( ( chr >= "A" and chr <= "Z" ) or
                 ( chr >= "a" and chr <= "z" ) or
                 ( chr >= "0" and chr <= "9" ) or
                 chr == "_" or chr == "'" or chr == "." ):
                continue
        print ( my_file, "to be wrapped>", i1, i2, my_line )
#        m_list.append( i1 )

        m_list.append( [i1, i2] )

    for ii in reversed ( m_list ) :
        i1 = ii[0]
        i2 = ii[1]
        print( i1, i2, ">", c_line[i1:i2], "<=>", my_wrap, "<" )

        str1 = "".join(c_line[:i1])
        str2 = "".join(c_line[i2:])
        strin = "".join(c_line[i1:i2])

        print (" string1 : >", str1, "<")
        print (" string2 : >", str2, "<")
        print (" strin   : >", strin, "<")
        new_string = str1 + my_wrap + "( " + strin + ") " + str2
        n_list = list(new_string)
        c_line = n_list[:]

    out_line = "".join(c_line)

    return out_line




############################################################
#
#      insert a new field in an array at position my_field
#
###########################################################

def insert_field_in_line(my_line, my_insert, my_field):
#    f = gzip.open('file.txt.gz', 'rb')
    m_list = list()
    c_line = list( my_line )
#    print ()
    print( " in>", my_line, "<" )
    out_line = my_line
    for m in re.finditer(my_pattern, my_line):
        i1 = int ( m.start() )
        i2 = int ( m.end() )
        if ( i2 >= len(c_line) ):
            continue
        print( " in>", ' 123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789', "<" )
        print("==>", my_pattern, ' found', m.start(), m.end(), ">", c_line[i1], "-", c_line[i2], "<" )

#        print ( "i1 in i2:", i1, i2 )
            
        if ( c_line[i2] == " " ):
            i2 = i2 + 1
            if ( i2 >= len(c_line) ):
                continue
        if ( c_line[i2] == " " ):
            i2 = i2 + 1
            if ( i2 >= len(c_line) ):
                continue
        if ( c_line[i2] == " " ):
            i2 = i2 + 1
            if ( i2 >= len(c_line) ):
                continue
        if ( c_line[i2] != "(" ):
            print( "---> out", my_pattern, cnt, ">", c_line[i2],"<", line )
            continue

        if ( i1 > 1 ):
            chr = c_line[i1-1]
            if ( ( chr >= "A" and chr <= "Z" ) or
                 ( chr >= "a" and chr <= "z" ) or
                 ( chr >= "0" and chr <= "9" ) or
                 chr == "_" ):
                print("<--- out", my_pattern, cnt, ">", c_line[i2],"<", line )
                continue

        print ( "-------      append             ------------ pattern with braces",  i2 )
        
#        m_list.append( i1 )
        m_list.append( i2 )

    m_break = -1
    for i2 in reversed(m_list):
        m_brace = "DO"
        m = i2
        m_lev = 1
        i3 = -1
        m_breaks = list()
        m_breaks.append( m )
        print (" break  top ", m, ">", c_line[m], "<" )
        while ( m < len(c_line)-1 ):
            m = m + 1
            if ( m_lev == 1 and c_line[m] == "," ):
                m_breaks.append( m )
                print (" break found", m, ">", c_line[m], "<" )
                # m_lev = m_lev + 1
            if ( c_line[m] == "(" ):
                m_lev = m_lev + 1
            if ( c_line[m] == ")" ):
                m_lev = m_lev - 1
            #print( "m>", c_line[m], "< level", m_lev )
            if ( m_lev == 0 ):
                i3 = m 
                m_brace = "DONE"
                break
        
    m_break = -1
    for i2 in reversed(m_list):
        m_brace = "DO"
        mm = 0
        m = i2
        mm_list = list()
        mm_list.append( m )
        m_lev = 1
        i3 = -1
        while ( m < len(c_line)-1 ):
            m = m + 1
            if ( m_lev == 1 and c_line[m] == "," ):
                mm = mm + 1
                mm_list.append( m )
                print (mm, " 2nd break found", mm, ">", c_line[m], "<" )
            if ( c_line[m] == "(" ):
                m_lev = m_lev + 1
            if ( c_line[m] == ")" ):
                m_lev = m_lev - 1
                print( "m>", c_line[m], "< level", m_lev )
                mm = mm + 1
                mm_list.append( m )

            if ( m_lev == 0 ):
                i3 = m 
                m_brace = "DONE"
                print ( "m_brace done", m, mm, m_brace )
                break
        

        if ( m_brace == "DONE" ):
            if ( mm > my_field ):
                m_break = mm_list[my_field]
                print (" m_break:", m_break, " >", c_line[m_break], "<" )
                str1 = "".join(c_line[:m_break+1])
                str2 = "".join(c_line[m_break+1:])
                print (" string1 : >", str1, "<")
                print (" string2 : >", str2, "<")
                new_string = str1 + my_insert + "," + str2
            elif ( mm == my_field ):
                m_break = mm_list[my_field]
                print (" l_break:", m_break, " >", c_line[m_break], "<" )
                str1 = "".join(c_line[:m_break])
                str2 = "".join(c_line[m_break:])
                print (" string1 : >", str1, "<")
                print (" string2 : >", str2, "<")
                new_string = str1 + "," + my_insert + str2
            else: 
                break
#            print (" strings: >", str1, "<*|*>", str2, "<")
            n_list = list(new_string)
            c_line = n_list[:]

        else:
            print ( my_file, ">", m_brace, m_lev, mm, my_field, "-> closure not found >>", i1, i2, my_line )

    out_line = "".join(c_line)
#    print( "out>", out_line, "<" )

    return out_line

def append_braces_in_line(f, my_line, my_append):
#    f = gzip.open('file.txt.gz', 'rb')
    m_list = list()
    c_line = list( my_line )
#    print ()
#    print( " in>", my_line, "<" )
    out_line = my_line
    for m in re.finditer(my_pattern, my_line):
        i1 = int ( m.start() )
        i2 = int ( m.end() )
        if ( i2 >= len(c_line) ):
            continue
        print( " in>", ' 123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789', "<" )
        print("==>", my_pattern, ' found', m.start(), m.end(), ">", c_line[i1], "-", c_line[i2], "<" )
        i0 = i2
#        print ( "i1 in i2:", i1, i2 )
        while ( c_line[i2] == " " and i2 < len(c_line)  ):
            i2 = i2 + 1

        if ( c_line[i2] != ")" and c_line[i2] != "," ):
            print( "---> out", my_pattern, cnt, ">", c_line[i2],"<", line )
            continue

        if ( i1 > 1 ):
            chr = c_line[i1-1]
            if ( ( chr >= "A" and chr <= "Z" ) or
                 ( chr >= "a" and chr <= "z" ) or
                 ( chr >= "0" and chr <= "9" ) or
                 chr == "_" ):
                print("<--- out", my_pattern, cnt, ">", c_line[i2],"<", line )
                continue

        print ( "-------      append             ------------ pattern with braces",  i2 )
        

#        m_list.append( i1 )
        m_list.append( i0 )

    m_break = -1
    for m_break in reversed(m_list):
        print (" l_break:", m_break, " >", c_line[m_break], "<" )
        str1 = "".join(c_line[:m_break])
        str2 = "".join(c_line[m_break:])
        print (" string1 : >", str1, "<")
        print (" string2 : >", str2, "<")
        new_string = str1 + "(" + my_append + ")" + str2
        n_list = list(new_string)
        c_line = n_list[:]

    out_line = "".join(c_line)
#    print( "out>", out_line, "<" )

    return out_line


###################################################################

my_commands = get_commands()
# print ( my_commands )

# print ( "my commands are:", len(my_commands) )

my_status = { 'entry': ['./'],
              'pattern': ['my_array'],
              'file': ['xx'],
              'delete': ['OFF'],
              'append': ['NONE_XX'],
              'insert': ['NONE_XX', -1],
              'replace': ['NONE_XX'],
              'swap': ['OFF'],
              'wrap': ['NONE_XX']
            }

fl_doit = 'FALSE'
fl_help = 'FALSE'

if ( len( my_commands ) == 0 ): 
    fl_help = 'TRUE'
else:
    for key, v in my_commands.items():
        print ( key, v )
        if ( key == 'e' or key == 'entry' ):
            my_status['entry'] = v 
        if ( key == 'f' or key == 'file' ):
            my_status['file'] = v 
#            my_status['file'].append( v )
        if ( key == 'p' or key == 'pattern' ):
            my_status['pattern'] = v
        if ( key == 'r' or key == 'replace' ):
            my_status['replace'] = v
        if ( key == 'a' or key == 'append' ):
            my_status['append'] = v
        if ( key == 'i' or key == 'insert' ):
            my_status['insert'] = v[:]
        if ( key == 'd' or key == 'delete' ):
            my_status['delete'] = v[:]
        if ( key == 's' or key == 'swap' ):
            my_status['swap'] = v[:]
        if ( key == 'w' or key == 'wrap' ):
            my_status['wrap'] = v[:]
        if ( key == 'h' or key == 'help' ):
            fl_help = 'TRUE'
        if ( key == 'doit' ):
            fl_doit = 'TRUE'

if ( fl_help == "TRUE" ):
    print ( "\n",
"-h| --help)       prints this message with available options and current setup status\n",
"-e| --entry)      entry point for origin directory tree search [", my_status['entry'], "]\n",
"-f| --file)       file name [", my_status['file'],  "]\n",
"-p| --pattern)    matching pattern [", my_status['pattern'],  "]\n",
"-d| --delete)     delete line with pattern [", my_status['delete'],  "]\n",
"-s| --swap)       swap [OFF/ON/ON4] [", my_status['swap'],  "]\n",
"-a| --append)     append a new field in array/scalar without it [", my_status['append'],  "]\n",
"-i| --insert)     insert new field in array [", my_status['insert'],  "]\n",
"-r| --replace)    replace [", my_status['replace'],  "]\n",
"-w| --wrap)       wrap variable in array [", my_status['wrap'],  "]\n",
"   --doit)           do the conversion\n"
    )
    exit()

my_dir = my_status['entry']
my_swap = my_status['swap'][0]
my_wrap = my_status['wrap'][0]
my_delete_line = my_status['delete'][0]
my_replace = my_status['replace'][0]
my_insert = my_status['insert'][0]
my_ins_field = int ( my_status['insert'][1] )
my_append = my_status['append'][0]
my_app_field = my_status['insert'][1] 
my_file = my_status['file']
my_pattern = "".join(my_status['pattern'])

print ( "my dir <", my_dir, ">", my_file , "<", my_pattern, "> swap", my_swap, "< replace", my_replace, "> insert<", my_insert, ">", my_ins_field, "< wrap>", my_wrap, "< delete>", my_delete_line, "< append>", my_append )

if ( fl_doit == "FALSE" ):
    exit()

t_list = list() 
#s = '*'.join(my_status['pattern'])
#print ( "s= [", s, "]" )

my_pat_file = list()
for p in my_file:
#    print ( " file pattern>", p )
    my_pat_file.append( re.compile( p, re.IGNORECASE ))

my_pat_vari = list()
for p in my_status['pattern']:
#    print ( " vari pattern>", p )
    my_pat_vari.append( re.compile( p, re.IGNORECASE ))


L = list(recursive_file_gen(my_dir) )
# for f in L:
#    print ( f )

m_list = list() 
if ( my_dir != ' ' ):
    for f in L:
        fl_match = "FALSE"
        if ( f[-3:] == "old"):
#            print ( ' ---> old is out', f )
            continue
        if ( f[-4:-1] == "old"):
#            print ( ' ---> old* is out', f )
            continue

        for p in my_pat_file:
#            print ( ' pattern match:', p )
            if ( re.search(  p, f ) ) :
                fl_match = "TRUE"
#                print ("true for file:", f )
#            else:
#                print ("false for file:", f )

        if ( fl_match == "TRUE" ) :
#            print ("true final ---> for file:", f )
            m_list.append(f)
                

for f in m_list:
    my_lines = list()
    my_lines = read_file(f)
    lng = len( my_lines )
    print ( " >> processing file:", f, lng )
    ii = 0
    new_file = list()
    nn = 0
    for line in my_lines:
        cnt = line.count( my_pattern )
        ii = ii + 1
#        print ( ii, cnt, line )
        if ( cnt <= 0 ):
            new_file.append( line )
            continue

        print( my_pattern, cnt, line )
        if ( my_swap == "ON"):
            new_line = swap_in_line( line, f )
            nn = nn + 1
            new_file.append( new_line )
            print ('  in>', line)
            print (' out>', new_line)
        elif ( my_append != "NONE_XX" ):
            new_line = append_braces_in_line( f, line, my_append )
            nn = nn + 1
            new_file.append( new_line )
            print ('  in>', line)
            print (' out>', new_line)
        elif ( my_insert != "NONE_XX" ):
            new_line = insert_field_in_line( line, my_insert, my_ins_field )
            nn = nn + 1
            new_file.append( new_line )
            print ('  in>', line)
            print (' out>', new_line)
        elif ( my_replace != "NONE_XX" ):
            new_line = replace_in_line( f, line, my_replace )
            nn = nn + 1
            new_file.append( new_line )
            print ('  in>', line)
            print (' out>', new_line)
        elif ( my_swap == "ON4"):
            new_line = swap4_in_line( line, f )
            nn = nn + 1
            new_file.append( new_line )
            print ('  in>', line)
            print (' out>', new_line)
        elif ( my_wrap != "NONE_XX"):
            new_line = wrap_in_line( f, line, my_wrap )
            nn = nn + 1
            new_file.append( new_line )
            print ('  in>', line)
            print (' out>', new_line)
        elif ( my_delete_line == "ON"):
            nn = nn + 1
            print ('dl in>', line)
        else:
            new_file.append( line )


    if ( nn > 0 ):
        write_file( f, new_file)








