#!/usr/bin/perl -w
# use strict;
#$my $test_key = 'Malhotra et al., 1998' ;
#print ">$test_key<\n" ;
print " @ARGV \n" ;
my %commands = () ;
my $in_file = "lit.txt" ;
my $lit_form = "etal" ;
my $out_file = "script.txt";
my $txt_form = "etal" ;
my $out_style = "alpha" ;

(%commands) = get_commands ( @ARGV ) ;
if ( scalar(@ARGV) <= 0 ) { push ( @{$commands{'help'}}, ' ' ) ; } 
my $i = 0 ; my $keyword ; 
foreach $keyword ( sort keys (%commands) ) 
{
    $i++ ; 
    print "$i.) >$keyword<:  @{$commands{$keyword}}\n";
    if ( $keyword eq 'i' || substr($keyword, 0,2) eq "in"  ) { goto IN }
    if ( $keyword eq 'o' || substr($keyword, 0,3) eq "out"  ) { goto OUT }
    print "REF_MAN: unknown keyword >$keyword<\n" ;
    next ;
    
  HELP:
    print" -i/--in     input file >$in_file< \n" ;
    print" -o/--out    output file >$out_file< \n" ;
    exit ;
  IN: 
	$in_file = shift ( @{$commands{$keyword}} ) ; 
	next ;
  OUT: 
	$out_file = shift ( @{$commands{$keyword}} ) ; 

	next ;
}
 print " text: >$out_file< lit: >$in_file< style: >$out_style< \n" ;
my @paper = read_para_file ( $in_file ) ;
write_file ( $out_file, @paper ) ;

exit ;

sub read_para_file_old
{  
    my $file_name = $_[0] ; my $new_line ; my $old_line ;
    my @in_line = () ;
    my @to_line = () ;
    my $prg = '' ;
    my @parag = () ;
    my $np_line = 0; 
    my @whole_file = () ;
    my $n_label ; my $n_targ ; my $I ;
    my $lab ; 
    my $lab_in ;
    my $line ; my $chr_test ;
    open ( TXT, $file_name ) || die "FILE OPEN ERROR: >$file_name< \n" ; 
#    print " read para_file: >$file_name<\n" ;
    my $nc ;
    my $continuation_flag ;
    $old_line = "" ;
    my $n_line = 0 ;
while(<TXT>)
{
    chomp ;
    $line = $_ ;
    $nc = length($line) ;
    $np_line++;
#    print "$np_line)", $line,"\n" ;
#    $new_line = "" ;
    $n_label = 0 ;
    $lab = "OK" ;
    $lab_in = "FALSE" ;
    @in_line = () ;
    $new_line = "" ;
    $continuation_flag = "FALSE" ;
    if ( $nc > 0 ) 
    {
	@in_line = split ('', $line ) ; @to_line = () ;
	if ( lc($in_line[0]) eq 'c' || $in_line[0] eq '!' ) 
	{ 
	    $in_line[0] = '!' ; 
	    $new_line = join ( '', @in_line ) ;
#	    print $nc, " >", $n_label, " comment \n" ;
#	    print " in coomment:", $new_line, "\n" ;
	}
	elsif ( lc($in_line[0]) eq '#' ) 
	{ 
	    $new_line = join ( '', @in_line ) ;
	    if ( $new_line =~ "include" ) 
	    { 
		if ( $new_line =~ "common" )
		{ $new_line =~ s/common/COMMON/; }
		elsif ( $new_line =~ "fcm" ) 
		{
		    if ( $new_line =~ "graph/" )
		    {$new_line =~ s/\"graph\//\"graph\/COMMON\//; }
		    else
		    {$new_line =~ s/\"/\"COMMON\//; }
		}
	    }
	    if ( $new_line =~ "ifdef" ) 
	    { $new_line =~ s/FOR90/FORTRAN_95/; }

#	    print "$nc: $n_label CPP \n" ;
	}
	else
	{
#	    print "$nc: $n_label REST" , @in_line, "\n" ;
	    $n_targ = 0 ;
	    my $first_non_space = -1 ;
	    while ($n_label <= 8 && $n_label < $nc ) 
	    {
#		print $nc, " >>", $n_label, " nlabel: \n" ;
		$chr_test = $in_line[$n_label] ;
#		print " $n_line.) 11 > ch $n_label {", $chr_test, "} $first_non_space - ", @in_line, "\n" ;
#		print $nc, " >>", $n_label, " nlabel:", $chr_test, " \n" ;
		if (  ( $lab eq "OK") && ( $chr_test ge '0') &&  ($chr_test le '9') )
#		if (  $lab eq "OK" )
		{
		    print " $nc.) NMB > ch $n_label {", $chr_test, "} $first_non_space - ", @in_line, "\n" ;
		    if ( $first_non_space < 0 ) 
		    {
#			print " NON SET label \n" ;
			if ( $n_label == 5 ) 
			{
			print " 5 CONTINUATION nmb space { }\n" ;
			    $continuation_flag = "TRUE" ;
			    push( @to_line, " " ) ; 
			    $lab = "NOT" ; 
			}
			else
			{			
			    print " NMB ch 6 }", $chr_test, "{\n" ;
			    $n_targ++ ; push ( @to_line, $chr_test ) ;
			}
			$first_non_space = $n_label ; 
		    }
		    elsif ( $first_non_space > 990 ) 
		    {
#			print " NON SET label $n_label\n" ;
			if ( $n_label == 1 ) 
			{
			print " 6 CONTINUATION number space { }\n" ;
			    $continuation_flag = "TRUE" ;
			    push( @to_line, " " ) ; 
			    $lab = "NOT" ; 
			}
			else
			{			
			    print " NMB push }", $chr_test, "{\n" ;
			    $n_targ++ ; push ( @to_line, $chr_test ) ;
			}
#			$first_non_space = $n_label ; 
		    }
		    else
		    {
		    print " $nc.) > NM push 9> $n_label $chr_test \n" ;
			$n_targ++ ; push ( @to_line, $chr_test ) ;
		    }
		    $lab_in = "TRUE" ;
		}
		elsif ( $chr_test ge ' ' ) 
		{
		    print " $nc.) ge > ch $n_label {", $chr_test, "} $first_non_space - ", @in_line, "\n" ;
		    if ( $chr_test gt ' ' && $first_non_space < 0 ) 
		    { 
			$first_non_space = $n_label ; 
#			print " NON SET ge $n_label\n" ;
			if ( $n_label == 5 )
			{
			    print " 5 CONTINUATION ge chrs \n" ;
			    $lab = "NOT" ; 
			    $continuation_flag = "TRUE" ;
			    push( @to_line, "   " ) ; 
			}
			else
			{
			    print " 6 extra PUSH }", $chr_test, "{\n" ;
			    $n_targ++ ; push ( @to_line, $chr_test ) ;
			}
		    }
		    else
		    {
			print " 7 extra PUSH }", $chr_test, "{\n" ;
			$n_targ++ ; push ( @to_line, $chr_test ) ;
		    }
		    if ( $lab_in eq "TRUE" ) { $lab = "NOT" ; }

		} 
		elsif ( $chr_test eq "\t" ) 
#		if ( $line =~ '\t' ) 
		{
		    print " $nc.) TAB > ch $n_label {", $chr_test, "}", @in_line, "\n" ;
		    $first_non_space = 999 ;
		    if ( $lab_in eq "TRUE" ) { $lab = "NOT" ; }
		    for ( $I = $n_label ; $I < 8 ; $I++ ) 
		    { 
			print " TAB fills }", $chr_test, "{\n" ;
			$n_targ++ ; push ( @to_line, " " ) ;
		    }
		    $chr_test = $in_line[1] ;
# # 		    if ( $nc > 1 )
# # 		    {
# # #			print " $nc.) > continuation  $n_label $chr_test", @in_line, "\n" ;
# # 			if ( $n_label <= 1 && $chr_test ge '0' &&  $chr_test le '9')
# # #		    if ( $chr_test ge '0' &&  $chr_test le '9')
# # 			 {
# # 			     $continuation_flag = "TRUE" ;
# # #			     $to_line[5] = "&" ;
# # 			     $to_line[5] = "   " ;
# # 			     $n_label++ ;
# # 			 }
# # 		    }
# # #		    print " $nc.) > TAB  $n_label \n" ;
#		    $n_label = 8 ;
		}
		$n_label++ ;
	    }
	    for ( $I = $n_label ; $I < $nc ; $I++ ) 
	    { 
		if ( $I > 2 && $in_line[$I] ne "\t" ) 
		{ 
		    print " $nc.) finals > $I {", $in_line[$I], "}\n" ;
		    push( @to_line, $in_line[$I] ) ; 
		} 
	    }

	    $new_line = join ( '', @to_line ) ;
	}
	
    }

#    print "$np_line>", $new_line, "\n" ;
    if ( $continuation_flag eq "TRUE" ) 
    {
	$old_line = join ('', $old_line, " &" ) ; 
    }

    if ( $n_line > 0 ) { push ( @whole_file, $old_line ); }
    $n_line++ ;
    $old_line = $new_line ;
}
    push ( @whole_file, $old_line );

    print " read para_file:done  >$file_name< records: $np_line\n" ;
close ( TXT ) ;
return ( @whole_file ) ;
}

sub read_para_file 
{  
    my $file_name = $_[0] ; my $new_line ; my $old_line ;
    my @in_line = () ;
    my @to_line = () ;
    my $prg = '' ;
    my @parag = () ;
    my $np_line = 0; 
    my @whole_file = () ;
    my $n_label ; my $n_targ ; my $I ;
    my $lab ; 
    my $lab_in ;
    my $line ; my $chr_test ;
    open ( TXT, $file_name ) || die "FILE OPEN ERROR: >$file_name< \n" ; 
#    print " read para_file: >$file_name<\n" ;
    my $nc ;
    my $continuation_flag ;
    $old_line = "" ;
    my $n_line = 0 ;
    my $first_chr_line ;

while(<TXT>)
{
    chomp ;
    $line = $_ ;
    $n_chrs = length($line) ;
    $np_line++;
#    print "$np_line)", $line,"\n" ;
#    $new_line = "" ;
    $n_chr_count = 0 ;
    $lab = "OK" ;
    $lab_in = "FALSE" ;
    @in_line = () ;
    $new_line = "" ;
    $continuation_flag = "FALSE" ;
    $first_chr_line = 0 ;
    if ( $n_chrs > 0 ) 
    {
	@in_line = split ('', $line ) ; @to_line = () ;
	if ( lc($in_line[0]) eq 'c' || $in_line[0] eq '!' ) 
	{ 
	    $in_line[0] = '!' ; 
	    $new_line = join ( '', @in_line ) ;
#	    print $n_chrs, " >", $n_chr_count, " comment \n" ;
#	    print " in coomment:", $new_line, "\n" ;
	}
	elsif ( lc($in_line[0]) eq '#' ) 
	{ 
	    $new_line = join ( '', @in_line ) ;
	    if ( $new_line =~ "include" ) 
	    { 
		if ( $new_line =~ "common" )
		{ $new_line =~ s/common/COMMON/; }
		elsif ( $new_line =~ "fcm" ) 
		{
		    if ( $new_line =~ "graph/" )
		    {$new_line =~ s/\"graph\//\"graph\/COMMON\//; }
		    else
		    {$new_line =~ s/\"/\"COMMON\//; }
		}
	    }
	    if ( $new_line =~ "ifdef" ) 
	    { $new_line =~ s/FOR90/FORTRAN_95/; }

#	    print "$n_chrs: $n_chr_count CPP \n" ;
	}
	else
	{
#	    print "$n_chrs: $n_chr_count REST>" , @in_line, "<\n" ;
	    $n_targ = 0 ;
	    $n_chr_count = 0 ;
	    my $first_space = -1 ;
	    my $first_non_space = -1 ;
	    my $first_tab = -1 ;
	    my $last_numb = -1 ; 
	    my $first_numb = -1 ;
	    while ($n_chr_count <= 8 && $n_chr_count < $n_chrs ) 
	    {
		
#		print $n_chrs, " >>", $n_chr_count, " nlabel: \n" ;
		$chr_test = $in_line[$n_chr_count] ;
#		print " $n_line.) 11 > ch $n_chr_count {", $chr_test, "} $first_non_space - ", @in_line, "\n" ;
#		print $n_chrs, " >>", $n_chr_count, " nlabel:", $chr_test, " \n" ;
		
		if ( $chr_test eq " " && $first_space < 0 ) {$first_space = $n_chr_count }
		if ( $chr_test gt " " && $first_non_space < 0 ) {$first_non_space = $n_chr_count }
		if ( $chr_test eq "\t" && $first_tab < 0 ) {$first_tab = $n_chr_count }
		if ( $chr_test ge '0' &&  $chr_test le '9' )
		{ 
		    if ( $first_numb < 0 ) 
		    {
			$first_numb = $n_chr_count; 
			$last_numb = $n_chr_count ;
		    }
		    if ( $last_numb + 1 == $n_chr_count )
		    {
			$last_numb = $n_chr_count ;
		    }
		}
		$n_chr_count++ ;
	    }
# 	    print "first_space    >", $first_space, "}", $in_line[$first_space], "{\n" ;
# 	    print "first_non_space>", $first_non_space, "}", $in_line[$first_non_space], "{\n" ;
# 	    print "first_tab      >", $first_tab      , "}", $in_line[$first_tab], "{\n" ;
# 	    print "first_numb     >", $first_numb     , "}", $in_line[$first_numb], "{\n" ;
# 	    print "last_numb      >", $last_numb      , "}", $in_line[$last_numb], "{\n" ;
 
	    if ( $first_space eq "0" && $first_non_space eq "5" && 
		 ( $first_tab < 0 || $first_tab > 5 ) )
	    {
		$continuation_flag ="TRUE" ;
		for ( $I = 0; $I < 5 ; $I++ ) 
		{ push( @to_line, $in_line[$I] ) ; } 
		push ( @to_line, "   " ) ;
		$first_chr_line = 6 ;
		if ( $first_tab >= 0 )
		{
		    for ( $I = $first_tab; $I <= 7 ; $I++ ) 
		    { push( @to_line, " ") ; } 
		    if ( $first_tab > $first_chr_line ) { $first_chr_line = $first_tab+1 ; }
#		    print " ERROR: unknown TAB possibility \n" ;
		}
	    }
	    elsif ( $first_tab >= 0 )
	    {
#		print " $n_chrs.) tab fills > { }\n" ;
		if ( $first_tab == 0 && $first_numb == 1 ) 
		{
#		    print " $n_chrs.) tab fills > {1}\n" ;
		    $continuation_flag ="TRUE" ;
		    push ( @to_line, "            " ) ;
		    $first_chr_line = 2 ;
		}
		elsif ( $last_numb < $first_tab )
		{
#		    print " $n_chrs.) tab fills > {2}\n" ;
		    for ( $I = 0; $I <= $last_numb ; $I++ ) 
		    { push( @to_line, $in_line[$I] ) ; 
#		      print " $n_chrs.) tabs digs > $I {", $in_line[$I], "}\n" ;
		    } 
		    for ( $I = $last_numb+1; $I <= 7 ; $I++ ) 
		    { 
#			print " $n_chrs.) tabs fills > $I { }\n" ;
			push( @to_line, " ") ; 
		    } 
		    $first_chr_line = $first_tab+1 ;
		}
		else
		{
#		    print " $n_chrs.) tab fills > {3}\n" ;
		    for ( $I = $first_tab; $I <= 7 ; $I++ ) 
		    { push( @to_line, " ") ; 
#			print " $n_chrs.) tabs fills > $I { }\n" ;
		    } 
		    $first_chr_line = $first_tab+1 ;
#		    print " ERROR: unknown TAB possibility }", $first_tab, " - ", $first_chr_line, "{ \n" ;
		}
	    }
	    elsif ( $first_tab < 0 && $first_space == 0 ) 
	    {
#		print " ERROR: normal case $np_line>", @in_line, "<\n" ;
	    }
	    else
	    {
		print " ERROR: unknown case $np_line>", @in_line, "<\n" ;
		print "first_space    >", $first_space, "}", $in_line[$first_space], "{\n" ;
		print "first_non_space>", $first_non_space, "}", $in_line[$first_non_space], "{\n" ;
		print "first_tab      >", $first_tab      , "}", $in_line[$first_tab], "{\n" ;
		print "first_numb     >", $first_numb     , "}", $in_line[$first_numb], "{\n" ;
		print "last_numb      >", $last_numb      , "}", $in_line[$last_numb], "{\n" ;
	    }

	    for ( $I = $first_chr_line ; $I < $n_chrs ; $I++ ) 
	    { 
#		print " $n_chrs.) finals > $I {", $in_line[$I], "}\n" ;
		if ( $in_line[$I] eq "\t" )
		{
		    my $J ;
#		    print " $n_chrs.) sncds tabs fills > $I to ", (($I+1) / 8 )*8, " { }\n" ;
		    for ( $J = $I; $J < (($I+1) / 8 )*8  ; $J++ ) 
		    { 
			push( @to_line, " ") ; 
		    } 
		}
		else
		{ push( @to_line, $in_line[$I] ) ; }
	    }

	    $new_line = join ( '', @to_line ) ;
	}
	
    }

#    print "$np_line>", $new_line, "\n" ;
    if ( $continuation_flag eq "TRUE" ) 
    {
	my @lins_c = split( '', $old_line ) ;
	my $c ;
	my $q_in = 0 ;
	my $cmnt_in = 0 ;
	foreach $c ( @lins_c)
	{
	    if ( $c eq "\'" )
	    { 
		if ( $q_in == 0 ) 
		{ $q_in = 1 ; } 
		else 
		{ $q_in = 0 ; }
	    }
	    if ( $c eq "!" )
	    { 
		if ( $q_in == 0 ) 
		{ $cmnt_in = 0 ; } 
		else 
		{ $cmnt_in = 1 ; }
	    }
	}


	if (  $cmnt_in == 0 )
	{ 
	    my @lins_w = split( '!', $old_line ) ;
	    my $w1 = shift ( @lins_w ) ;
	    $old_line = join ('', $w1, " & !", @lins_w ) ; 
	}
	else
	{ 
	    $old_line = join ('', $old_line, " &" ) ; 
	}

    }

    if ( $n_line > 0 ) { push ( @whole_file, $old_line ); }
    $n_line++ ;
    $old_line = $new_line ;
}
    push ( @whole_file, $old_line );

    print " read para_file:done  >$file_name< records: $np_line\n" ;
close ( TXT ) ;
return ( @whole_file ) ;
}

sub write_file
{
    use FileHandle ;
    my $file_name = shift ; 
    my @text_file = @_ ;

    open( TXT, ">$file_name" )  || die ; 
#    my $TXT = new FileHandle ( "> $file_name" )  || die ; 
    my $prg ;
    foreach $prg ( @text_file ) 
    {
	print TXT $prg, "\n" ;
    }
    close (TXT) ;
}


sub get_commands
{
    my $key = "" ;
    my $word ;
    my %c_line = () ;
    my @arg_char = () ;
    foreach $word ( @_ )
    {
	@arg_char = split( '', $word ) ;
#	print "word: $word \n" ; 
	if ( length($word) <= 0 ) { next ; }
	if ( $word !~ m"[a-zA-F]" ) { } #print "word: $word is a number\n" ; }
	else 
	{ 
#	    print "word: $word is a NON-number\n" ; 

	    if ( $arg_char[0] eq '-' ) 
	    {
		if ( $arg_char[1] eq "-" ) 
		{
		    my $num = scalar(@arg_char) - 1;
		    $key = join ( "", @arg_char[2 .. $num] );
		    push ( @{$c_line{$key}}, ' ' ) ; 
		}
		else
		{
		    $key = $arg_char[1] ; 
		    push ( @{$c_line{$key}}, ' ' ) ; 
		}
		next ;
	    }
	}

	if ( $key ne '' ) 
	{ 
	    $key = lc ( $key ) ; 
#	print "$key: \n" ;
	    my $tmp = join ( '', @{$c_line{$key}} ) ; 
	    if ( $tmp eq ' ' ) { delete $c_line{$key} ; }
	    push ( @{$c_line{$key}}, $word ); 
	}
    }
    return ( %c_line ) ;
}

