subroutine char SEGMENTS char SEG_KICKS int MAP_REAL int MAP_IDEAL \
    int MAP_INDEX int i1 int ilast int THE_SLIT int THE_BORDER

! the variable that tells how many residues will be during the
! omit map calculation calculation is THE_SLIT

set vari i2 = i1 + THE_SLIT
set vari ii1 int = i1 - THE_BORDER
if ( ii1 .le. 0 ) set vari ii1 int = 1
key active sele by seq resi numb ii1  i2 + THE_BORDER \
	.a segm name SEG_KICKS end

make map MAP_REAL conv real
make map MAP_REAL zero 
make map MAP_REAL atom symm \
     atom dens \
     sele segm name SEG_KICKS .a .not active end  
 fourier map MAP_REAL 
 reflection select defined end r-values 

make map MAP_REAL zero
make map MAP_REAL conv complex
refl set ampl phase fwork = fcalc * 1.
refl set ampl scale fcalc     fwork = fobs * 1. - fcalc * 1.
refl fill-map MAP_REAL select defined end
four map MAP_REAL back 
make map MAP_REAL rescale

make map MAP_INDEX from MAP_IDEAL ini inte around 8 sele active end
make map MAP_INDEX from MAP_IDEAL atom index 0.1 1000. \
                  sele resi numb i1 i2 end

set vari MAP_LOCAL = MAP_INDEX + 1
make map MAP_LOCAL from MAP_INDEX real init empty
make map MAP_LOCAL atom mask 3. sele resi numb i1 i2 end
make map MAP_LOCAL from MAP_REAL copy
make map MAP_LOCAL from MAP_IDEAL rescale

anal dens ( r-maps base-map = MAP_LOCAL ideal-map = MAP_IDEAL \
     index = MAP_INDEX ) \
     sele weight 0.1 1.1 .and. segm name SEGMENTS \
	.a resi numb i1  i2 end
set vari i1 = i1 + THE_SLIT
if ( i1 .gt. ilast ) return
rewind file
