subroutine int MAP_IN int MAP_OUT real HIST_TEMP

!The zero flat

make map MAP_IN set -10000 -9900 0.0

! The flipping - inverting the rest - the solomon way

!set vari SOLV_CUT = 0.5
!set vari GAMMA = 1. - SOLV_CUT
!set vari GAMMA = GAMMA / SOLV_CUT * -1.0
!make map MAP_IN set -10000 -9900 9999.0
!make map MAP_IN from MAP_OUT invert reshift rescale scale GAMMA 


fourier map MAP_IN
reflect sele WORK_REFL end shell 10  r-values 
refl set ampl phase fwork = fcalc * 1

! At this point you can call the MAIN atomic probability function
if ( HIST_TEMP .gt. 2.0 ) <>utils/hist_match int MAP_IN real HIST_TEMP

!  after you get new structure factors
!  you can perform a phase combination procedure 
!  using sigmaa weighting scheme:
!     adapt the main/doc/dens_mod/phase_comb (main_2_sigmaa_2_main.ccp4) script
!     and calculate an fobs map

! write over file main_fcalc.phase refl polar select defined end
! spawn main_2_sigmaa_2_main.ccp4  > sigmma.out
! read file sigmaa.phase refl over resol RESOL_MIN RESOL_MAX friedel
! < ?MAIN_CMDS:calc_fo_map.cmds MAP_OUT

! or calculate some other kind of map

< ?MAIN_CMDS:calc_fo_phase_fc.cmds MAP_OUT

! < ?MAIN_CMDS:calc_fofc_diff_map.cmds MAP_OUT 2 1

return

