subroutine char SEGM_FROM char SEGM_TO char ATOMS real CUT_OFF char METHOD

! if you provide your own pair list - simply comment out all
! the other two pair lists options

! pair list created with distance checks
if ( METHOD .eq. "CALC" ) then

calc pair ( init sele segm name SEGM_FROM .a atom name ATOMS end \
      sele segm name SEGM_TO .a atom name ATOMS end range 0. CUT_OFF )
show pair
end_if

! pairs by sequence checks
if ( METHOD .eq. "MATCH" ) then
make pair init sele segm name SEGM_FROM .a atom name ATOMS end \
      sele segm name SEGM_TO .a atom name ATOMS end sequen ! name_match
show pair

end_if
! The first fitting

rms coor all eigen pair 
rota atom sele segm name SEGM_FROM end rms
tran atom sele segm name SEGM_FROM end rms

if ( METHOD .eq. "USE" ) return

echo " REF ITTT"
! refitting by recalculating the pair list 
! using 2 RMS (sigma) criterion befor the final fit
if ( 2 * rms_fi .lt. CUT_OFF ) set vari CUT_OFF = 2 * rms_fi
calc pair ( init sele segm name SEGM_FROM .a atom name ATOMS end \
      sele segm name SEGM_TO .a atom name ATOMS end range 0. CUT_OFF )

! do the rotation and translations of the FROM molecules
rms coor all eigen pair 
rota atom sele segm name SEGM_FROM end rms
tran atom sele segm name SEGM_FROM end rms

return
