< ?MAIN_UTILS:get_top_par_19_csd
! ATOMS SECTION

set vari FILE_ATOM = SAVE_FILE.PDB 
set vari FILE_CTAB = SAVE_FILE.CTAB

read file FILE_ATOM atom pdb
set vari WORK_SEGM char global segm sele all end 
 set rad sele segm name WORK_SEGM end vdw

read file FILE_CTAB ctable
show bonds
if ( IRESULT_0 .le. 0 ) <>utils/calculate.bonds WORK_SEGM

<DEF_ALL WORK_SEGM
define init group 
set charge sele .not atom name C CA N H O .a \ 
    resi name ASP GLU LYS ARG end = 0.0

! CRYSTAL FORM 1
set vari FILE_CELL = cell.dat
set vari FILE_SYMM = "?MAIN_SYMM:c2_2_21.symm"
set vari FILE_FOBS = diffract.dat
set vari RESOL_MIN global real = 83.05
set vari RESOL_MAX global real = 2.50

read file FILE_CELL cell 
read file FILE_SYMM symm 
read file FILE_FOBS refl init MAIN limit 0 0 0 \
   reso RESOL_MIN RESOL_MAX friedel re_read 

set vari IRESULT_0 global = -1 
refl show key TEST
if ( IRESULT_0 .le. 0 ) then 
refl key TEST sele random 20 1 end 
end_if
refl key WORK_REFL sele defined .a .not TEST end
! map section

make map from 0 init -9999 auto_grid cell real
set vari MAP_CRYS_1 = nmaps
make map from nmaps init -9999 

set vari MAP_2FOFC global inte = MAP_CRYS_1 
set vari MAP_FO global inte = MAP_CRYS_1 
set vari MAP_FOFC global inte = MAP_CRYS_1 + 1 
set vari MAP_WORK global inte = MAP_CRYS_1 + 1 

ener all on dens on dens map MAP_2FOFC dens scal 25.

!      final part: opening display, unit cell, chain trace ...

ima init cent calc
<SAVE_FILE.VIEW
!<>utils/rama
<>utils/show.cell


ima sele atom name CA C N .a segm name WORK_SEGM end col 1 bond
ima from erase
 ima col 245 map 1 dens 0.8 16 16 16 
 ima col  90 map 2 dens 2.0 16 16 16

<?MAIN_CMDS:re_image.cmds WORK_SEGM

return
