set vari CYCLE = CYCLE + 1
sh vari CYCLE
if CYCLE .gt. CYCLE_N return

! rotating and adding density maps together

read file mask_hex.xmap map xpl over 3
make map 3 from 1 copy

read file mask_hex.xmap map xpl over 4
<mol_hex_to_ortho
!set matr 4 inv 3
make map 4 from 2  \
    rota matr 3 \
    tran vect XTRAN YTRAN ZTRAN \
    center coor 0 0 0 
!wr over file dens_ort_to_hex.xmap map 4 xpl


make map 3 from 4 add
make map 3 rescale
!wr over file dens_aver_hex.xmap map 3 xpl


read file mask_ortho.xmap map xpl  over 4
make map 4 from 2 copy

read file mask_ortho.xmap map xpl
<mol_ortho_to_hex
make map 5 from 1  \
    rota matr MAT_ROT \
    tran vect XTRAN YTRAN ZTRAN \
    center coor 0 0 0 
!wr over file dens_hex_to_ort.xmap map 5 xpl


make map 4 from 5 add
make map 4 rescale
!wr over file dens_aver_ortho.xmap map 4 xpl

<get_data_hex
read file FILE_CELL cell
read file FILE_SYMM symm
read file FILE_REFL reflect init resol RESOL_HEX 100. limit 0 0 0 friedel
set vari MAP_CELL = 1
make map MAP_CELL zero
make map MAP_CELL set -1 1 -9999.
make map MAP_CELL from 3 cell


<calc_a_map

<get_data_ortho
read file FILE_CELL cell
read file FILE_SYMM symm
read file FILE_REFL reflect init resol RESOL_ORT 100. limit 0 0 0 friedel
set vari MAP_CELL = 2
make map MAP_CELL zero
make map MAP_CELL set -1 1 -9999.
make map MAP_CELL from 4 cell
<calc_a_map
rewind file 

