set vari CYCLE = CYCLE + 1
sh vari CYCLE
if CYCLE .gt. CYCLE_N return

set vari MAP_DENS = MAP_CELL + 1

! rotating and adding density maps together

set vari FILE_MASK mol1_mask.xmap
set vari FILE_DENS mol1_dens.xmap 
read file FILE_MASK map xpl over MAP_DENS
make map MAP_DENS from MAP_CELL copy
<mol_1_to_2
<add_a_map
make map MAP_DENS rescale


write over file FILE_DENS map MAP_DENS xplor

set vari FILE_MASK mol2_mask.xmap
set vari FILE_DENS mol2_dens.xmap 
read file FILE_MASK map xpl over MAP_DENS
make map MAP_DENS from MAP_CELL copy
<mol_2_to_1
<add_a_map
make map MAP_DENS rescale
write over file FILE_DENS map MAP_DENS xplor



! unit cell density generation

! unit cell clearing steps
! use map zero step only if you get density values out of range -9999 9999

make map MAP_CELL zero  
make map MAP_CELL set -99999 99999 -9999.

! repeat this part until you have read in all of your averaged maps

set vari FILE_DENS = mol1_dens.xmap
<aver_map_to_cell

set vari FILE_DENS = mol2_dens.xmap
<aver_map_to_cell

! calculate a new map

<calc_a_map

rewind file 

