set lev 2
set vari FILE_CELL cb-inh-p21.cell
set vari FILE_SYMM >symm/p21.symm
set vari FILE_REFL cb-inh-p21.fobs
set vari FILE_ATOM hucathb_10t_2.xpl
set vari CYCLE_N = 4
set vari MAT_ROT = 8

read file FILE_CELL cell
read file FILE_SYMM symm
read file FILE_REFL reflect init resol 3. 8. limit -99 -99 0
read file FILE_ATOM atom pdb

rename segm MOL1 sele segm name CBA1 CBB1 end 
rename segm MOL2 sele segm name CBA2 CBB2 end 

<rms_fit

set vari MAP_CELL = 1
set vari GRID_A = 128   !    herm fft direction - must be even 
set vari GRID_B = 48
set vari GRID_C = 128

make map MAP_CELL from 0 init -9999 grid GRID_A GRID_B GRID_C  cell real

<make_masks

make map MAP_CELL \
     atom dens select segm name MOL1 MOL2 end \
     atom symmetry
<calc_a_map

set vari CYCLE = 0

<aver_loop

write over file aver_dens.xmap map MAP_CELL xpl
write over file aver_fcalc.refl reflect fobs fcalc polar defined

quit
