	program avemap
	parameter (nbmaps=7000000)
	dimension  bmaps(nbmaps), imaps(nbmaps)
	dimension rmimap(2), rts(12,50)
	character*132 line
	integer*2 imaps, ii
	character*1 bmaps
c	lun1 = 1
	iu = 2
99	format( 80a1 )
	nmaps = 0
1	continue
	write(*,*) ' INPUT MAP FILE NAME:'
	read(*,99,err=900) (line(j:j),j=1,80)
	if ( line(1:2) .eq. '-1' ) goto 2
	open ( unit = iu, file = line, status = 'old',
     * carriagecontrol = 'list', err = 100 )
	nmaps = nmaps + 1
	call rdline ( iok, iu, line, leng, level )
	if ( iok .gt. 0 ) goto 100
	if ( iok .lt. 0 ) goto 102
	if ( leng .le. 0 ) goto 101
	call wrline ( iok, iout, line, leng, 1 )
	read(line(1:leng),12,err=104) acell, bcell, ccell, 
     * calpha, cbeta, cgama
	call rdline ( iok, iu, line, leng, level )
	if ( iok .gt. 0 ) goto 100
	if ( iok .lt. 0 ) goto 102
	if ( leng .le. 0 ) goto 101
	call wrline ( iok, iout, line, leng, 1 )
	read(line(1:leng), *)  na, nb, nc, ia1, ib1, ic1, ma, mb, mc, 
     * nsymm
	if ( nsymm .gt. 0 ) then
c	read(iu, 89) (j,((rts(3*k+i,j),k=1,3),i=1,3), 
c     * (rts(i,j),i=1,3), j=1,nsymm)
	read (iu, 89) (ij,(rts(i,j),i=1,12), j=1,nsymm)
	end if
	call rdline ( iok, iu, line, leng, level )
	if ( iok .gt. 0 ) goto 100
	if ( iok .lt. 0 ) goto 102
	if ( leng .le. 0 ) goto 101
	call wrline ( iok, iout, line, leng, 1 )
	read( line(1:leng),12) ( rmimap(j), j=1,2)
	mapadr = ma*mb*mc
	if ( mapadr .gt. nbmaps ) goto 103
12	format( 6e12.5 )
	write(*,*) ' RD_MAP> adresses', nmaps, mapadr
	read(iu,14,err=101) (bmaps(i), i=1,mapadr) 
14	format(80a1)
	close ( unit = iu )
	if ( nmaps .eq. 1 ) then
	do 18 i = 1, mapadr
	ii = ichar(bmaps(i))
	imaps(i) = ii
18	continue
	else
	do 19 i = 1, mapadr
	ii = ichar(bmaps(i))
	imaps(i) = imaps(i) + ii
19	continue
	end if
	goto 1
c do the averaging
2	continue
	if ( nmaps .le. 0 ) stop ' NO MAPS READ'
	write (*,*) ' AVERAGED OVER ', nmaps, '   MAPS'
	rmaps = float(nmaps)
	do 20 i = 1, mapadr
	i1 = imaps(i)
	rval = float(i1)
	rval = rval / rmaps + 0.5
	bmaps(i) = char(ifix(rval))	
20	continue
c
	write(*,*) ' OUTPUT MAP FILE NAME:'
	read(*,99,err=900) (line(j:j),j=1,80)
	open ( unit = iu, file = line, status = 'new',
     * carriagecontrol = 'list', err = 104 )
c
111	format( 10i5 )
	write( line(1:80), 12 ) acell, bcell, ccell, 
     * calpha, cbeta, cgama
	call wrline ( iok, iu, line, 80, -5 )
	write(line(1:50), 111)  na, nb, nc, ia1, ib1, ic1, ma, mb, mc,
     * nsymm
	call wrline ( iok, iu, line, 50, -5 )
	if ( nsymm .gt. 0 ) then
c	write(ires, 89) (j,((rts(3*k+i,j),k=1,3),i=1,3), 
c     * (rts(i,j),i=1,3), j=1,nsymm)
	write(iu, 89) (j,(rts(i,j),i=1,12), j=1,nsymm)
89	format( i5, 3f10.3,/,5x, 3f10.3,/,5x,3f10.3,5x,3f10.3)
	end if
	write( line(1:24),12) ( rmimap(j), j=1,2)
	call wrline ( iok, iu, line, 24, -5 )
	write( iu, 14 ) (bmaps(i), i=1,mapadr)
	stop ' AVE_MAP DONE'
c	write(0,*) 'i, inte, del, del/delta, ichar(bmaps(i)), '
100	write(*,*) ' FILE NOT FOUND:', LINE(1:40)
	stop
101	write(*,*) ' READ ERROR'
	stop
102	write(*,*) ' EMPTY LINE IN FILE HEADER'
	stop
103	write(*,*) ' TOO LARGE DENSITY ARRAY', ma*mb*mc
	stop
104	write(*,*) ' ERROR WRITEING MAIN DENSITY FILE'
	stop
900	stop ' SYS$INPUT READ ERROR'
	end
C
c
c ----------------------------------------
c
c writes a line of text to unit iu
c
	subroutine wrline ( iok, iun, line, leng, level )
	character*132line
	iok = 0
	write ( iun, 1, err=100 ) (line(j:j),j=1,leng)
1	format( 132a1 )
	return
100	continue
	iok = 1
	return
	end
c
c ----------------------------------------
c
c reads a line of text from unit iu
c
	subroutine rdline ( iok, iu, line, leng, level )
	character*132 line
	leng = 0
	iok = 0
	read ( iu, 1, end=200, err=100 ) (line(j:j),j=1,132)
1	format( 132a1 )
	do 2 i = 132,1,-1
	if ( line(i:i) .eq. ' ' ) goto 2
	leng = i
	return
2	continue
	return
c error
100	continue
	iok = 1
	return
c end of file
200	continue
	iok = -1
	return
	end
