      program test_coarray
c      integer :: m[*]

      real, allocatable :: rmap(:), rw(:)[:]
      integer idim, i, j, m
      idim = 50

       allocate (rmap(idim), rw(idim)[*])

c      m = THIS_IMAGE()
       if (THIS_IMAGE() == 1) then
          print *, " top", NUM_IMAGES()
       end if
       SYNC ALL
c     do m = 1, 
       if (THIS_IMAGE() == 1) then
          do i = 1, idim
c             print *, i, " in", i+m-1, "image ", m
             do m = 1, NUM_IMAGES() 
                rw(i)[m] = m
             end do
          end do
       end if
       SYNC ALL
       
       rmap = 0
       do i = 1, idim
          rmap(j) = 0
       end do
       
       if (THIS_IMAGE() == 1) then
          do i=1, NUM_IMAGES()
             do j = 1, idim
                rmap(j) = rmap(j) + rw(j)[i]
             enddo
          enddo
       endif
       deallocate ( rw)

       SYNC ALL

       do i = 1, 10, NUM_IMAGES()
c          m = mod( NUM_IMAGES(), i ) + 1
c          write(*,*) ' m=', m
          j = i
          call run_image1(j,m)
          j = j + 1
          call run_image2(j,m)
          j = j + 1
          call run_image3(j,m)
       end do

       SYNC ALL
       if (THIS_IMAGE() == 1) then
          write(*,*) ' rmap:', (rmap(j), j=1,10)
       end if

       
       end

      subroutine run_image1(j,m)
      integer m, i, j
      do i = 1,5
         write(*,*) j, " in image 1>", i*m
      end do
      return
      end

      subroutine run_image2(j,m)
      integer i, m, j
      do i = 1,5
         write(*,*) " in image 2>", i*m
      end do
      return
      end

      subroutine run_image3(j,m)
      integer i, m, j
      do i = 1,5
         write(*,*) " in image 3>", i*m
      end do
      return
      end
