#!/usr/bin/perl -w


use strict;
use lib $ENV{ 'MAIN_CONF'}  ;
use main_config ;

my @lines ;

my $file_name = "scattering_factors.dat" ;
open ( TXT, $file_name ) || die "FILE OPEN ERROR: >$file_name< \n" ; 

my $np_line ;
my $line ;
my $scatr ;

while(<TXT>)
{
    chomp ;
    $line = $_ ;
    $np_line++ ;
    push ( @lines, $line );
}
close ( TXT ) ;

my $key ;
$key = "----" ;

my %scat_factors ;
my %scat_atoms ;
my @factors = () ;
my @words ;
foreach $line ( @lines )
{
    $scatr = substr( $line, 0,2 ) ;
    if ( $scatr ne "  " ) 
    {
	if ( $key ne "----" ) 
	{
	    @{$scat_factors{$key} } = @factors ;
#    printf, " %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, %s \n", @factors, $key,  ;
	    if ( $key !~  /\+/ && $key !~  /\-/ ) 
	    {printf " %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, ! %s %d\n",@factors,  $key, $scat_atoms{$key} ;}
#	    printf " scattr: {%s} %8.4f %8.4f %8.4f %8.4f %8.4f %8.4f %8.4f %8.4f %8.4f \n", $key, @factors ;
	    @factors = () ;
	}
	$key = substr( $line, 0,4 ) ;
	$key =~ s/ //g ;
	@words = split(" ", $line) ;
	$scat_atoms{$key} = $words[1] ;
    }
    else
    {
	@words = split(" ", $line) ;
	push ( @factors, @words ) ;
    }
}

if ( $key ne "----" ) 
{
    @{$scat_factors{$key} } = @factors ;
    printf " %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, %8.4f, ! %s %d \n", @factors, $key, $scat_atoms{$key} ;
   @factors = () ;
}
