	program dn6map
	parameter (nbmaps=8000000)
	dimension  bmaps(nbmaps)
	character*80 line
	character*1 bmaps
	dimension rhodat(4), index(3)
      COMMON /MAPIN1/ IOXYZ(3), NXYZ(3), IUVW(3),  IGRID(3), CELL(6)
      COMMON /MAPIN2/ RHORNG(6), NRHO 
      COMMON /MAPIN3/ PROD,  IPLUS, IHIST(256)
	common /symm/ nsymm, rts(12,60)
c
	common /buff/ iu, irec, int2(256)
	integer*2 int2
	byte int1(512)
	equivalence (int2(1), int1(1))
c
1000	continue
	write(*,*) ' INPUT DSN6 MAP FILE:'
	read (*, '(a80)' ) line
	iu = 1
	open ( unit=iu, file=line, recordtype='fixed', 
     * status='old', form='unformatted', readonly, err=1000 )
c	defin file 1 ( 32767, 256, u, indx )
	nsymm = 0
	call rdhead( iok )
	if ( iok .ne. 0 ) stop ' head :ERROR'
	write(*,*) ' ORIG ', ioxyz
	write(*,*) ' NCEL ', nxyz
	write(*,*) ' GRID ', igrid
	write(*,*) ' prod, plus', prod, iplus
	rhmin = float( 3 - iplus ) / prod
	rhmax = rhmin + 250. / prod
	index(1) = 1
	index(2) = 2
	index(3) = 3
	nz = (nxyz(index(3))+7)/8
	ny = (nxyz(index(2))+7)/8
	nx = (nxyz(index(1))+7)/8
	write(*,*) ' nx ny nz', nx, ny, nz
c	read(*,*) nx, ny, nz
	do 1 iz = 1, nz
	izb = (iz-1) * 8
	do 1 iy = 1, ny
	iyb = (iy-1) * 8
	do 1 ix = 1, nx
	ixb = (ix-1) * 8
	call rdrec( iok )
c	write(*,*) ' nx ny nz', ix, iy, iz, iok
	if ( iok .ne. 0 ) stop ' record ERROR'
	ii = 0
	do 2 jz = 0, 7
	do 2 jy = 0, 7
	do 2 jx = 0, 7
	ii = ii + 1
	iadr = (ixb + jx) + (iyb + jy)*nxyz(1)  + 
     * (izb + jz)*nxyz(1)*nxyz(2)+ 1
	if ( ixb+jx .gt. nxyz(1) .or. (iyb+jy) .gt. nxyz(2) .or.
     * izb+jz .gt. nxyz(3)) goto 2
	bmaps(iadr) = char( int1(ii) )
2	continue
1	continue
	ires = 2
1001	continue
	write(*,*) ' CELL CONSTANTS'
	read(*,*) (cell(j), j=1,6)
	write(*,*) ' OUTPUT MAIN MAP FILE:'
	read (*, '(a80)' ) line
	open ( unit = ires, file = line, status = 'new',
     * carriagecontrol = 'list', err = 1001 )
c
12	format( 6e12.5 )
111	format( 10i5 )
	write(ires,12) cell
	write(ires, 111) igrid, ioxyz, nxyz, nsymm
	if ( nsymm .gt. 0 ) then
	write(ires, 89) (j,((rts(3*k+i,j),k=1,3),i=1,3), 
     * (rts(i,j),i=1,3), j=1,nsymm)
c	write(ires, 89) (j,(rts(i,j),i=1,12), j=1,nsymm)
89	format( i5, 3f10.3,/,5x, 3f10.3,/,5x,3f10.3,5x,3f10.3)
	end if
	write(ires,12) rhmin, rhmax
c	write(0,*) 'i, inte, del, del/delta, ichar(bmaps(i)), '
	ii = 0
	nmaps = nxyz(1)*nxyz(2)*nxyz(3)
	write(ires, 44 ) (bmaps(i), i=1, nmaps)
44	format( 80a1) 
	end
c
	subroutine rdhead( iok )
	parameter (nbmaps=8000000)
	dimension bmaps(nbmaps)
	character*1 bmaps
      COMMON /MAPIN1/ IOXYZ(3), NXYZ(3), IUVW(3),  IGRID(3), CELL(6)
      COMMON /MAPIN2/ RHORNG(6), NRHO 
      COMMON /MAPIN3/ PROD,  IPLUS, IHIST(256)
c
	common /buff/ iu, irec, int2(256)
	integer*2 int2
c
c --- fill up our first record
	irec = 0
	call rdrec( iok )
	if ( iok .lt. 0 ) write(*,*) ' EMPTY FILE'
	if ( iok .ne. 0 ) return
	do 100 i=1,3
	ioxyz(i) = int2(i)
	nxyz(i) = int2(i+3)
	igrid(i) = int2(i+6)
	cell(i) = float(int2(i+9))
	cell(i+3) = float(int2(i+12)) / float(int2(18))
100	continue
	int16 = int2(16)
	int19 = int2(19)
	prod = float(int16)/ float( int19)
	iplus = int2(17)
	write (6,11)(cell(i),i=1,6)
11	format (/,2x,'cell constants being read from dsn6:',/,
     *       6f10.5)
	return
	end
c
c    read record
c
	subroutine rdrec( iok )
	common /buff/ iu, irec, int2(256)
	integer*2 int2
	iok = 0
	irec = irec + 1
	read (iu,end=100, err=999 ) int2
	return
100	continue
	iok = -1
	write(*,*) ' error reading record: end of file', irec
	return
999	continue
	iok = 1
	write(*,*) ' error reading record', irec
	return
	end
