	program mapfft
	parameter (nbmaps=7000000)
	parameter ( nrlmax=1000000 )
      PARAMETER ( LUN6 = 6 )
	dimension CELL(6)
	INTEGER MIFD(9), IPERM(3), ind(3), irev(3)
	dimension nabc(3), iorig(3), mxyz(3), igrid(3)
	common / symm/ nsymm, rts(12,60)
	dimension  rlayer(nrlmax)
	dimension rmimap(2) 
	character*132 line
	character*1 bmaps(nbmaps)
	parameter (maxbuf = 4000 )
	common /buf/ iu, ibg, bufmax(maxbuf), next, iblid
	byte bufmax
c
c	lun1 = 1
	next = 0
	iu = 2
99	format( 80a1 )
	nmaps = 0
980	continue
	write(*,*) ' INPUT MAP FILE NAME:'
	read(*,99,err=900) (line(j:j),j=1,80)
	if ( line(1:2) .eq. '-1' ) goto 2
	open ( unit = iu, file = line, status = 'old',
     * carriagecontrol = 'list', err = 980 )
	nmaps = nmaps + 1
	call rdline ( iok, iu, line, leng, level )
	if ( iok .gt. 0 ) goto 100
	if ( iok .lt. 0 ) goto 102
	if ( leng .le. 0 ) goto 101
c	call wrline ( iok, iout, line, leng, 1 )
	read(line(1:leng),12,err=104) cell
	call rdline ( iok, iu, line, leng, level )
	if ( iok .gt. 0 ) goto 100
	if ( iok .lt. 0 ) goto 102
	if ( leng .le. 0 ) goto 101
c	call wrline ( iok, iout, line, leng, 1 )
	read(line(1:leng), *)  nabc, iorig, mxyz, nsymm
	if ( nsymm .le. 0 ) then
	write(*,*) ' NO SYMMETRY INFORMATION IN THE FILE'
	nsymm = 1
	do 20 k = 1,12
	rts(k,1) = 0.0
20	continue
	rts(4,1) = 1.0
	rts(8,1) = 1.0
	rts(12,1) = 1.0
	else
	read(iu, 89) (j,((rts(3*k+i,j),k=1,3),i=1,3), 
     * (rts(i,j),i=1,3), j=1,nsymm)
89	format( i5, 3f10.3,/,5x, 3f10.3,/,5x,3f10.3,5x,3f10.3)
	end if
	call rdline ( iok, iu, line, leng, level )
	if ( iok .gt. 0 ) goto 100
	if ( iok .lt. 0 ) goto 102
	if ( leng .le. 0 ) goto 101
c	call wrline ( iok, iout, line, leng, 1 )
	read( line(1:leng),12) ( rmimap(j), j=1,2)
c	rmimap(1) = rmimap(1) * 0.01
c	rmimap(2) = rmimap(1) * 0.01
	mapadr = mxyz(1)*mxyz(2)*mxyz(3)
	if ( mapadr .gt. nbmaps ) goto 103
12	format( 6e12.5 )
111	format( 9i5 )
	write(*,*) ' RD_MAP> adresses', nmaps, mapadr
	read(iu,14,err=101) (bmaps(i), i=1,mapadr) 
14	format(80a1)
	close ( unit = iu )
	ind(1) = 1
	ind(2) = 2
	ind(3) = 3
c	if ( mxyz(ind(3)) .lt. mxyz(ind(2)) ) then
c	ii = ind(2)
c	ind(2) = ind(3)
c	ind(3) = ii
c	end if
c	if ( mxyz(ind(3)) .lt. mxyz(ind(1)) ) then
c	ii = ind(1)
c	ind(1) = ind(3)
c	ind(3) = ii
c	end if
c
990	continue
	iu = 1
	write(*,*) ' OUTPUT FFT DENSITY FILE NAME:'
	read(*,99,err=900) (line(j:j),j=1,80)
	open ( unit = iu, file = line, carriagecontrol='list',
     * form='unformatted',recl=2044, status = 'new', err = 990 )
	write(*,*) ' FFT TITLE : '
	read(*,99,err=900) (line(j:j),j=1,80)
	write(1)line(1:80)
	write(*,*) ' FFT SCALING FACTOR:'
	read(*, '(f)' ) scale
	if ( scale .eq. 0.0 ) scale = 1.0
c	scale = 1. / 100.
	write(*,*) ' befou:', rmimap, scale
	rmimap(1) = rmimap(1) * scale
	rmimap(2) = rmimap(2) * scale
	write(*,*) ' scale:', rmimap, scale
	delta = (rmimap(2) - rmimap(1))/ 255. 
	n1 = mxyz(1)
	n2 = mxyz(2)
	if ( n1 * n2 .gt. nrlmax ) stop ' LAYER TOO LARGE'
	nlayer = iorig(2)
c	do 1 i2 = 0, nabc(2)-1
	do 1 i2 = 0, mxyz(2)-1
	ndens = 0
	do 2 i3 = 0, mxyz(3)-1
	do 2 i1 = 0, mxyz(1)-1
	nn = i1 + i2*mxyz(1) + i3*mxyz(1)*mxyz(2) +1
	ival = ichar(bmaps(nn))
	ndens = ndens + 1
	rlayer(ndens) = (rmimap(1) + float(ival ) * delta) 
2	continue
	call putlay ( nlayer, iorig, mxyz, rlayer, ndens )
	nlayer = nlayer + 1
1	continue
	ieof=-1
	write(1)(ieof,j=1,5)
	stop 'O.K.'
100	write (*,*) ' RD_MAP> ERROR: READING MAP FILE TITLE '
	stop
101	write (*,*) ' RD_MAP> ERROR: EMPTY LINE'
	stop
102	write ( *,* ) ' RD_MAP> END OF FILE DETECTED'
	stop
103	write ( *,* ) ' RD_MAP> NUMBER OF POINTS OVER BOUNDRIES'
	stop
104	write ( *,* ) ' RD_MAP> ERROR: READING MAP FILE'
	stop
900	stop ' FILE OPEN ERROR'
	end
C
c
c ----------------------------------------
c
c writes a line of text to unit iu
c
	subroutine wrline ( iok, iun, line, leng, level )
	character*132line
	iok = 0
	write ( iun, 1, err=100 ) (line(j:j),j=1,leng)
1	format( 132a1 )
	return
100	continue
	iok = 1
	return
	end
c
c ----------------------------------------
c
c reads a line of text from unit iu
c
	subroutine rdline ( iok, iu, line, leng, level )
	character*132 line
	leng = 0
	iok = 0
	read ( iu, 1, end=200, err=100 ) (line(j:j),j=1,132)
1	format( 132a1 )
	do 2 i = 132,1,-1
	if ( line(i:i) .eq. ' ' ) goto 2
	leng = i
	return
2	continue
	return
c error
100	continue
	iok = 1
	return
c end of file
200	continue
	iok = -1
	return
	end
c
c
	subroutine putlay ( nlayer, iorig, mxyz, rlayer, nn )
	integer*4 iorig(3), mxyz(3)
	real*4 rlayer(1000000)
c
c	write(*,*) nlayer, iorig, mxyz, nn
	write(1)nlayer, iorig(1), (iorig(1)+mxyz(1)-1),
     * iorig(3), (iorig(3)+mxyz(3)-1)
	write(1) (rlayer(j), j=1, nn )
	return
	end	
c
