	program mapout
	parameter (nbmaps=7000000)
	parameter ( nrlmax=1000000 )
      PARAMETER ( LUN6 = 6 )
	dimension CELL(6)
	INTEGER MIFD(9), IPERM(3), ind(3), irev(3)
	dimension nabc(3), iorig(3), mxyz(3), igrid(3)
	common / symm/ nsymm, rts(12,60)
	dimension  bmaps(nbmaps), layer(nrlmax)
	dimension rmimap(2) 
	character*132 line
	integer*2 imaps, ii, layer
	character*1 bmaps
	parameter (maxbuf = 4000 )
	common /buf/ iu, ibg, bufmax(maxbuf), next, iblid
	byte bufmax
c
c	lun1 = 1
	next = 0
	iu = 2
99	format( 80a1 )
	nmaps = 0
	write(*,*) ' INPUT MAP FILE NAME:'
	read(*,99,err=900) (line(j:j),j=1,80)
	if ( line(1:2) .eq. '-1' ) goto 2
	open ( unit = iu, file = line, status = 'old', readonly,
     * carriagecontrol = 'list', err = 900 )
	nmaps = nmaps + 1
	call rdline ( iok, iu, line, leng, level )
	if ( iok .gt. 0 ) goto 100
	if ( iok .lt. 0 ) goto 102
	if ( leng .le. 0 ) goto 101
	call wrline ( iok, iout, line, leng, 1 )
	read(line(1:leng),12,err=104) cell
	call rdline ( iok, iu, line, leng, level )
	if ( iok .gt. 0 ) goto 100
	if ( iok .lt. 0 ) goto 102
	if ( leng .le. 0 ) goto 101
	call wrline ( iok, iout, line, leng, 1 )
	read(line(1:leng), *)  nabc, iorig, mxyz, nsymm
	if ( nsymm .le. 0 ) then
	write(*,*) ' NO SYMMETRY INFORMATION IN THE FILE'
	nsymm = 1
	do 20 k = 1,12
	rts(k,1) = 0.0
20	continue
	rts(4,1) = 1.0
	rts(8,1) = 1.0
	rts(12,1) = 1.0
	else
	read(iu, 89) (j,((rts(3*k+i,j),k=1,3),i=1,3), 
     * (rts(i,j),i=1,3), j=1,nsymm)
89	format( i5, 3f10.3,/,5x, 3f10.3,/,5x,3f10.3,5x,3f10.3)
	end if
	call rdline ( iok, iu, line, leng, level )
	if ( iok .gt. 0 ) goto 100
	if ( iok .lt. 0 ) goto 102
	if ( leng .le. 0 ) goto 101
	call wrline ( iok, iout, line, leng, 1 )
	read( line(1:leng),12) ( rmimap(j), j=1,2)
	mapadr = mxyz(1)*mxyz(2)*mxyz(3)
	if ( mapadr .gt. nbmaps ) goto 103
12	format( 6e12.5 )
111	format( 9i5 )
	write(*,*) ' RD_MAP> adresses', nmaps, mapadr
	read(iu,14,err=101) (bmaps(i), i=1,mapadr) 
14	format(80a1)
	close ( unit = iu )
	ind(1) = 1
	ind(2) = 2
	ind(3) = 3
c	if ( mxyz(ind(3)) .lt. mxyz(ind(2)) ) then
c	ii = ind(2)
c	ind(2) = ind(3)
c	ind(3) = ii
c	end if
c	if ( mxyz(ind(3)) .lt. mxyz(ind(1)) ) then
c	ii = ind(1)
c	ind(1) = ind(3)
c	ind(3) = ii
c	end if
c
	write(*,*) ' OUTPUT PROTEIN MAP FILE NAME:'
	read(*,99,err=900) (line(j:j),j=1,80)
	open ( unit = iu, file = line, 
     * form='unformatted',maxrec=2044, status = 'new', err = 900 )
	ibg = 0
	iperm(1) = ind(2)
	iperm(2) = ind(1)
	iperm(3) = ind(3)
	igrid(1) = nabc(iperm(1))
	igrid(2) = nabc(iperm(2))
	igrid(3) = nabc(iperm(3))
	mifd(1) = iorig(iperm(1))
	mifd(4) = iorig(iperm(2))
	mifd(7) = iorig(iperm(3))
	mifd(2) = iorig(iperm(1)) + mxyz(iperm(1))-1
	mifd(5) = iorig(iperm(2)) + mxyz(iperm(2))-1
	mifd(8) = iorig(iperm(3)) + mxyz(iperm(3))-1
	mifd(3) = 1
	mifd(6) = 1
	mifd(9) = 1
	nsym = 1
	call put012 ( iu, CELL, NSYM, IPERM, IGRID, MIFD, IERROR)
	delta = (rmimap(2) - rmimap(1))/ 255.
	n1 = mxyz(iperm(1))
	n2 = mxyz(iperm(2))
	if ( n1 * n2 .gt. nrlmax ) stop ' LAYER TOO LARGE'
	nlayer = 0
	do 1 i = 0, mxyz(iperm(3))-1
	irev(iperm(3)) = i
	ndens = 0
	nlayer = nlayer + 1
	do 2 i1 = 0, mxyz(iperm(1))-1
	irev(iperm(1)) = i1
	do 2 i2 = 0, mxyz(iperm(2))-1
	irev(iperm(2)) = i2
	nn = irev(1) + irev(2)*mxyz(1) + irev(3)*mxyz(1)*mxyz(2) +1
	ival = ichar(bmaps(nn))
	ndens = ndens + 1
	layer(ndens) = ( ival - 128 ) * 256
2	continue
	call putlay ( nlayer,n1,n2, layer, rmimap)
	call clrbuf
1	continue
	stop 'O.K.'
100	write (*,*) ' RD_MAP> ERROR: READING MAP FILE TITLE '
	stop
101	write (*,*) ' RD_MAP> ERROR: EMPTY LINE'
	stop
102	write ( *,* ) ' RD_MAP> END OF FILE DETECTED'
	stop
103	write ( *,* ) ' RD_MAP> NUMBER OF POINTS OVER BOUNDRIES'
	stop
104	write ( *,* ) ' RD_MAP> ERROR: READING MAP FILE'
	stop
900	stop ' FILE OPEN ERROR'
	end
C
c
c ----------------------------------------
c
c writes a line of text to unit iu
c
	subroutine wrline ( iok, iun, line, leng, level )
	character*132line
	iok = 0
	write ( iun, 1, err=100 ) (line(j:j),j=1,leng)
1	format( 132a1 )
	return
100	continue
	iok = 1
	return
	end
c
c ----------------------------------------
c
c reads a line of text from unit iu
c
	subroutine rdline ( iok, iu, line, leng, level )
	character*132 line
	leng = 0
	iok = 0
	read ( iu, 1, end=200, err=100 ) (line(j:j),j=1,132)
1	format( 132a1 )
	do 2 i = 132,1,-1
	if ( line(i:i) .eq. ' ' ) goto 2
	leng = i
	return
2	continue
	return
c error
100	continue
	iok = 1
	return
c end of file
200	continue
	iok = -1
	return
	end
c
c
      SUBROUTINE put012 (LUN, CELL, NSYM, IPERM, IGRID, MIFD, IERROR)
	common / symm/ nsymm, rts(12,60)
C
C   PS300 FRODO version 6.3  (JSS  01-JAN-1987)
C
C   MAPIN subroutine GET012 is used to read in the Protein style header records
C
C   Original Source from PS300 FRODO version 5.5  (JWP & MAS  01-JAN-1984)
C
      PARAMETER ( DEGTOR = 180./3.141593 , LUN6 = 6 )
      INTEGER IPERM(3), IGRID(3), MIFD(9), TITLE(6) 
      REAL    CELL(6)     
	parameter (maxbuf = 4000 )
	common /buf/ iu, ibg, bufmax(maxbuf), next, iblid
	byte bufmax
C
C   Read the type zero record
C
c      READ (LUN,ERR=900) IBLID,IP,NWR,
c     1     (TITLE(I),I=1,4),IFT,(TITLE(I),I=5,6)
	iblid = 0
	ift = 3
	nwr = 7
	write(*,*) ' TITLE:'
	read(*,10) (title(i), i=1,4)
10	format( 4a4)
	write(*,*) ' DATE:'
	read(*,10) (title(i), i=5,6)
	ibg = 0
	call putbyt( nwr, 4 )
	call putbyt( title, 16 )
	call putbyt( ift, 4 )
	call putbyt( title(5), 8 )
	ibg=3536
	call clrbuf
c      write (LUN ) IBLID,IP,nwr,
c     1     (TITLE(I),I=1,4),IFT,(TITLE(I),I=5,6)
C
C   Read the type 1 record
C
	iblid = iblid + 1
C
C  Convert COS(ANGLE) to ANGLE
C
      DO 100 I  = 4,6
      CELL(I) = COS(CELL(I) / DEGTOR )
  100 CONTINUE
c      READ (LUN,ERR=900) IBLID,IP,NWR,CELL,NSYM
	nwr = 7 + nsymm * 12
	call putbyt( nwr, 4 )
	call putbyt( cell, 24 )
	call putbyt( nsymm, 4 )
	nss = 48 * nsymm
	call putbyt( rts, nss )
	ibg=3536
	call clrbuf
c      write (LUN,ERR=900) IBLID,IP,NWR,CELL,NSYMm,
c     * ((rts(i,j),i=1,12), j=1,nsymm)
C
C   Read the type 2 record
C
	iblid = iblid + 1
	ipatt = 0
	nwr = 13
c      READ (LUN,ERR=900) IBLID,IP,NWR,IPATT,IPERM,IGRID,MIFD
	call putbyt( nwr, 4 )
	call putbyt( ipatt, 4 )
	call putbyt( iperm, 12 )
	call putbyt( igrid, 12 )
	call putbyt( mifd, 36 )
	ibg=3536
	call clrbuf
c      write (LUN,ERR=900) IBLID,IP,NWR,IPATT,IPERM,IGRID,MIFD
c      IF (IPATT.LT.0 .OR. IPATT.GT.1) GO TO 940
      RETURN
C
C   Errors
C
  900 IERROR        = 1
      WRITE (LUN6,2000)
      RETURN
C
  910 IERROR        = 2
      WRITE (LUN6,2100) IBLID
      RETURN
C
  920 IERROR        = 3
      WRITE (LUN6,2200) IFT
      RETURN
C
  930 IERROR       = 4
      WRITE (LUN6,2300)  (CELL(I),I=4,6)
      RETURN
C
  940 IERROR       = 5
      WRITE (LUN6,2400)  IPATT
      RETURN
C
 2000 FORMAT (' MAP> ERROR reading map header record')
 2100 FORMAT (' MAP> ERROR reading map block-id  = ',I5)
 2200 FORMAT (' MAP> ERROR in map file type = ',I5)
 2300 FORMAT (' MAP> ERROR in map cosine(s) out of range:', 3F15.6)
 2400 FORMAT (' MAP> ERROR in map IPATT type = ',I5)
      END
c
	subroutine putlay ( nlayer, n1, n2, layer, rmimap )
	integer*2 layer(1), iblank
	parameter (maxbuf = 4000 )
	common /buf/ iu, ibg, bufmax(maxbuf), next, iblid
	byte bufmax	
	dimension rmimap(2)
	logical fmore
	data iblank/0/

c
	iblid = 5
	iadr = 1
	n22 = n2 * 2
	fmore = .false.
	if ( mod(n2,2) .ne. 0 ) fmore = .true.
	ibg = 0
	nwr = 3
	nlayr = nlayer+1
	call putbyt( nwr, 4 )
	call putbyt( nlayr, 4 )
	call putbyt( n1, 4 )
	call putbyt( n2, 4 )
c	write(*,*) ' PUT_LAY> ', nlayer, n1, n2, nwr
	if ( fmore ) then
	nwr = ifix( float(n2) * 0.5) + 3
	else
	nwr = ifix( float(n2) * 0.5) + 2
	end if
c	write(*,*) ' nwr', nwr, n2, fmore
	do 1 i = 1, n1
	if ( ibg + 12 + n22 .gt. maxbuf ) call clrbuf
c	write(*,*) ' 1', nwr
	call putbyt( nwr, 4 )
c	write(*,2) ibg, nwr, (bufmax(kl),kl=ibg-3, ibg),nwr, 
c     * (bufmax(kl),kl=ibg-3, ibg)
c2	format( ' 2', 6i5, z10, 4z3 )
	call putbyt( rmimap, 8 )
	call putbyt( layer(iadr), n22 )
	iadr = iadr + n2
	if ( fmore ) call putbyt( iblank, 2 )
1	continue
	return
	end	
c
	subroutine putbyt( inbyt, nn )
	parameter (maxbuf = 4000 )
	common /buf/ iu, ibg, bufmax(maxbuf), next, iblid
	byte bufmax
	byte inbyt(1)
c	if ( ibg + nn .gt. maxbuf ) call clrbuf
	do 1 i = 1, nn
	bufmax(ibg+i) = inbyt(i)
1	continue
	ibg = ibg + nn
	return
	end
c
	subroutine clrbuf
	parameter (maxbuf = 4000 )
	common /buf/ iu, ibg, bufmax(maxbuf), next, iblid
	byte bufmax
	dimension int4(1000)
	equivalence (int4(1), bufmax(1))
	integer*2 ip, nb
	data ip/0/
c	iwr = nb * 4
	next = next + 1
c	write(*,*) ' CLRBUF> ibg', ibg, next
	nb = ibg / 4 
	write(iu ) iblid, ip, nb, (int4(i), i=1,nb)
	ibg = 0
	return
	end
