C============================================================================
	PROGRAM MAPFFTZ
c	problem with overhanging density on x and y corrected
c       7/16/86 jk
c	kuriyan program
c-------These declarations are in MAPFFTZ.FCM:
c-------PARAMETER MAX_RHO = 32000
c-------DIMENSION RHO(MAX_RHO)   20/12/83,dmf added dimension rhotmp(max_rho)
c-------INTEGER YLEVS,PLUS
c-------LOGICAL*1 SLICE
c-------COMMON/PAGE/IOXYZ(3),IMXYZ(3),MYGRID(3),CELL(6)
c-------COMMON/DENS/PROD,PLUS,NX,NY,NZ,SLICE(8,MAX_RHO),
c-------1           RHO,RHORNG(2),NRHO
c-------COMMON/LUNITS/LUN1,LUN2,INDXRA
	include 'MAPFFTZ.FCM'
	character*4 teneyk(2),bricogne(2)
	CHARACTER*4 SECDIR
	data teneyk(1)/'zyx'/,teneyk(2)/'ZYX'/
	data bricogne(1)/'zxy'/,bricogne(2)/'ZXY'/
	integer iendpoint(3),igrid(3)
	integer*4 ihist(256)
	equivalence (imxyz(3),Zlevs)
	logical doopen
      INTEGER NTITLE,MXTITL,TITMAX
      PARAMETER (MXTITL=32,TITMAX=80)
      CHARACTER*(TITMAX) TITLE(MXTITL)
	define file 12 (32767,256,u,indx)
	lun1=11
	lun2=12
	indxra=0
	n=max_rho
	nrho = 0
	rhorng(1)=1.0e7
     	rhorng(2)=-1.0e7
      READ(LUN1,'(/I8)') NTITLE
      READ(LUN1,'(A)') (TITLE(J),J=1,NTITLE)
      WRITE(6,'(A)') (TITLE(J),J=1,NTITLE)
	read(lun1,'(9I8)')(mygrid(i),ioxyz(i),iendpoint(i),i=1,3)
80	format(9i5)
800	format(9f10.5)
	do i=1,3
	 imxyz(i) = iendpoint(i)-ioxyz(i) + 1
	end do
	read (lun1,'(6E12.5)')(cell(i),i=1,6)
C_ATB         	read (5,810)prod,plus
        read (lun1,'(A)')
        PROD=0.0
        PLUS=0.0
C_ATB	read (5,815)secdir
        SECDIR='ZYX'
	WRITE(6,816)SECDIR
	idir = -999
c       bricogne means his modification of the teneyk fft program,
c	in which output is lefthanded ysect/zfast,xslow  ie local version
	if (secdir.eq.bricogne(1).OR.secdir.eq.bricogne(2)) then
	 write (6,804)
	 idir=1
	end if
	if (secdir.eq.teneyk(1).or.secdir.eq.teneyk(2)) then
	 write (6,803)
	 idir=2
	end if
	if (idir.ne.1.and.idir.ne.2) then
	 write (6,802)	
	 stop
	end if
804	format (/,2x,'Map will be read sectioned in Z sections, with ',
	1            'X slow, Y fast')
803	format (/,2x,'Map will be read sectioned in Z sections, with ',
	2            'Y slow , X fast')
802	format (/,2x,'Map format not accepted !!  Stopping.')
810	format(f12.6,i5)
	write (6,805)(mygrid(i),ioxyz(i),imxyz(i),i=1,3)
805	format (/,/,2x,'Map parameters read from input stream.',/,
	1       2x,' number of grid points along cell edge A ',i5,
	1       1x,'lowest x point in map ',i5,' number of x points',
	1       ' in map ',i5,/,
	1       2x,' number of grid points along cell edge B ',i5,
	1       1x,'lowest y point in map ',i5,' number of y points',
	1        ' in map ',i5,/,
	1       2x,' number of grid points along cell edge C ',i5,
	1       1x,'lowest z point in map ',i5,' number of z points',
	1        ' in map ',i5)
815	FORMAT(A4)
816	FORMAT(1X,'SECTIONING DIRECTIONS READ AS :',A4)
c
c	compute size of a page
c
	i4=imxyz(1)
	i4=i4*imxyz(2)
	if (i4.le.n) goto 200
	write (6,300)i4,max_rho
300	format(2x,'size of layer in map is too large.',/,
	1      2x,'Current value is ',i7,/,
	1      2x,'Maximum value is ',i7)
	stop
200	nx=imxyz(1)/8
	if (mod(imxyz(1),8).ne.0) nx=nx+1
	ny=imxyz(2)/8
	if (mod(imxyz(2),8).ne.0) ny=ny+1
	nz=imxyz(3)/8
	if (mod(imxyz(3),8).ne.0) nz=nz+1
	write (6,310)nx,ny,nz
310	format(/,2x,'Number of cubes along x,y,z are ',3i5)
	if (prod.gt.0.0) goto 50
	call calprod(i4,imxyz(1),imxyz(2),idir)
50	call wthead
	doopen=.TRUE.
	do I =1,ZLEVS
	 call MAPIN(DOOPEN,ILEV,imxyz(1),imxyz(2),idir,I4)
	 call paged(imxyz(1),imxyz(2),ILEV,iundflo,iovflo,ihist)
	end do
	call rest(imxyz(1),imxyz(2),ilev)
	write (6,850)nrho,iundflo,iovflo
850	format(/,/,/,2x,'MAPFFTZ DONE >>>',/,
	1       2x,'Number of density points counted : ',i7,/,
	2       2x,'Number of scaled points lt than 0 : ',i7,/,
	3       2x,'Number of scaled points gt than 255 : ',i7)
c
c	histogram evaluation in blocks of 4 
	write (6,961)
	do ih=1,16
	 do ihh=1,16
	  in=(ih-1)*16+ihh
	  ilump=ilump + ihist(in)
	 end do
	 ir1 = (ih-1)*16 + 1
	 ir2 = (ih)*16
	 write (6,960)ir1,ir2,ilump
	 ilump=0
	end do	 
c
961	format (/,/,2x,'Histogram in Blocs of 16 from 1 to 256')
960	format (2x,i3,':',i3,5x,i12,/)
	stop
	end
C============================================================================
C=====CALPROD
	subroutine calprod(i4,ngx,ngy,idir)
	include 'MAPFFTZ.FCM'
	real title(20)
	ll=-1
	rewind lun1
      READ(LUN1,'(/I8)') NTITLE
      do j=1,ntitle 
      READ(LUN1,'(A)') 
      end do
        READ (LUN1,'(A)')
        READ (LUN1,'(A)')
        READ (LUN1,'(A)')
C_ATB (title(i),i=1,20)
C_ATB   	write (6,50)(title(i),i=1,20)
C_ATB50	format(/,2X,'Title read from input density file:',/,
C_ATB	1      2x,20a4)
100	read(lun1,'(I8)',end=800)l
c       modified to handle -512 terminator for skew maps
c       look for + to - switch. not neccesary in mapin
	if (l.lt.0.and.ll.gt.0) goto 800
	ll=l
	if (idir.eq.1) then
	 read(lun1,'(6E12.5)')(rho(j),j=1,i4)
	else
	 read(lun1,'(6E12.5)')(rhotmp(j),j=1,i4)
	 indx2 = 0
	 do inx=1,ngx
	  do iny=1,ngy
	   indx2 = indx2 + 1
	   indx1 = ngx * (iny-1) + inx
	   rho(indx2) = rhotmp(indx1)
	  end do
	 end do
	end if
c	 	 
	do j = 1,i4
	 if (rho(j).gt.rhorng(2))rhorng(2)=rho(j)
	 if (rho(j).lt.rhorng(1))rhorng(1)=rho(j)
	end do
	goto 100
800	rhodif = rhorng(2) - rhorng(1)
	prod=0.0
	if (rhodif.gt.0.0) prod=250./rhodif
	plus = 3 - prod*rhorng(1)
	write(6,900)prod,plus,rhorng(1),rhorng(2)
900	format (/,/,2x,' Calculated Product & Plus: ',f12.6,i8,
	1      /,' Rhomin = ',e12.6,'Rhomax = ',e12.6)
	return
	end
C=====PAGED=======
	SUBROUTINE PAGED(IX,IY,ILEV,iundfl,iovfl,ihist)
c
c
c	variables:------
c	
c	RHO(max_rho)  : COntains density for one level
c	INDXRA        : Index for records in FRODO DSN6 direct access
c			file. See below for how it is calculated
c	PROD,PLUS     : Scaling factors to bring density into 1-255 range
c	NX,NY,NZ      : Number of 8-grid-point blocks along X,Y and Z unit cell
c			edges
c	IX,IY	      : Total number of grid points along X and Y
c	ILEV	      : z level being read 
c     SLICE(8,max_rho): Contains  a slice of the map 8 sections deep.
c			Subsequently broken up into 8*8*8 cubes.
c	RECORD(512)   : Contains one 8*8*8 cube in byte data. Written to
c			DSN6 in direct access.
c	VALUE         : A one byte varaible assigned the value 0 so as
c			'pack' overextending cubes.
c
c   SECTIONING INFORMATION:
c	This program reads z-sections of electron density in the format
c	put out by FFT (TenEyck)
c	Frodo expectst the DSN6 file to be written out as if from a
c	Z-sectioned map. The indices to SLICE and RECORD are worked out
c	as follows:
c     i) The indices to SLICE(i,j) are given by
c	 i = value of ilev mod 8
c	 j = (X-1)*IY + Y where X and y are the grid coordinates of the point.
c        correction to above 20/12/83 dmf
c    ii) The index to RECORD(i) is given by:
c	 K3,J3 are the X,Z grid coordinates
c	 I is MOD(ilev,8) (1,2,...8)
c	 K4 is MOD(K3,8)  (1,2,...8)
c	 J4 is MOD(J3,8)  (1,2,...8)
c	 i = (J4 -1)*64 + (I-1)*8 +K4
c
c----CODE STARTS HERE
	INCLUDE 'MAPFFTZ.FCM'
	LOGICAL*1 RECORD(512),VALUE
	INTEGER*2 IVALUE,IRECRD(256)
	integer*4 ihist(256)
	EQUIVALENCE (RECORD(1),IRECRD(1))
C
	i1 = mod(ilev,8)
	i2 = ilev/8
	if (i1.eq.0) i1 = 8
	ict = 0
	do 100 i=1,ix
	 do 100 j=1,iy
	  ict=ict+1
	  rhosc=(rho(ict)*prod) + plus
	  if (rhosc.gt.30000.0) rhosc=30000.0
	  ivalue=rhosc
	  if (ivalue.gt.255) then
	   ivalue=255
	   iovfl=iovfl+1
	  end if
	  if (ivalue.lt.0) then
	   ivalue=0
	   iundfl=iundfl + 1
	  end if
	  do ih=1,256
	   if (ivalue.lt.ih) then
	    ihist(ih)=ihist(ih)+1
	    goto 100
	   end if 
	  end do
100	call makbyt(slice(i1,ict),ivalue)
c
	if (i1.ne.8) return
	write(6,4)i2
4	format(/,2x,'Writing out density at Z-cube level: ',i5)
	call makbyt(value,0)
c
	ict = 0
c.......Loop over cubes along Y edge
	do 110 j = 1,ny
	 j1 = (j-1)*8 + 1
	 j2 = j*8
c        Loop over X edge
	 do 110 k = 1,nx
	  k1 = (k-1)*8 + 1
	  k2 = k*8
c	  read this cube in from slice
	  ICT = 0
	  do 120 izc = 1,8
	   do 120 iyc = j1,j2
	    do 120 ixc = k1,k2
	     jct = (ixc-1)*iy + iyc
	     ict = ict + 1
	     if (iyc.gt.iy.or.ixc.gt.ix) goto 140
	     record(ict)=slice(izc,jct)
	     goto 120
140	     record(ict) = value
120	   continue
	indxra = indxra + 1
110	write (lun2'indxra)irecrd
	return
	end
C==========================================================
C=====REST
C
	SUBROUTINE REST(IX,IY,ILEV)
C
C	This writes out any density thats overhanging the Y-edge
C	and is almost identical to PAGED in structure.
	INCLUDE 'MAPFFTZ.FCM'
	LOGICAL*1 RECORD(512),VALUE
	INTEGER*2 IVALUE,IRECRD(256)
	EQUIVALENCE (RECORD(1),IRECRD(1))
C
	i1 = mod(ilev,8)
	i2 = ilev/8
	if (i1.eq.0) return
c       
	i2 = i2 + 1
	write (6,4)i2
4	format(/,2x,'Writing out cubes at Y-cube level:',i5)
c	Do not have to read any density because SLICE has already
c	been filled by PAGED.
	call makbyt(value,0)
c
	ict = 0
c.......Loop over cubes along Y edge
	do 110 j = 1,ny
	 j1 = (j-1)*8 + 1
	 j2 = j*8
c        Loop over X edge
	 do 110 k = 1,nx
	  k1 = (k-1)*8 + 1
	  k2 = k*8
c	  read this cube in from slice
	  ICT = 0
	  do 120 izc = 1,8
	   do 120 iyc = j1,j2
	    do 120 ixc = k1,k2
	     jct = (ixc-1)*iy + iyc
	     ict = ict + 1
	     if (izc.gt.i1.or.iyc.gt.iy.or.ixc.gt.ix) goto 140
	     record(ict)=slice(izc,jct)
	     goto 120
140	     record(ict) = value
120	   continue
	indxra = indxra + 1
110	write (lun2'indxra)irecrd
	return
	end
C === MAKBYT ===
      SUBROUTINE MAKBYT(VALUE,IVALUE)
C --- VAX SPECIFIC,THE BYTE IS IN THE FIRST ELEMENT OF EQUIV.
C       (THIS CONVERTS THE LESS SIGNIF BYTE OF A TWO-BYTE
C         INTEGER INTO A 1-BYTE UNSIGNED INTEGER "IN THE RANGE 0-255".
C         SIMPLE VAX-FORTRAN ASSIGNMENT MIGHT DO EXACTLY THE SAME.
C	  THE ACTUAL KEY TO USING THE BYTE AS AN UNSIGNED INTEGER
C          IS THAT THE ROUTINE READING THE BYTE USES FUNCTION IBYTE
C          RATHER THAN SIMPLE VAX-FORTRAN ASSIGNMENT (INTEGER=BYTE).
      LOGICAL*1 VALUE,L(2)
      INTEGER*2 IVALUE,J
      EQUIVALENCE (L(1),J)
      J = IVALUE
      VALUE = L(1)
      RETURN
      END
C === WTHEAD ===
	SUBROUTINE WTHEAD
C	WRITE FIRST OUTPUT RECORD
	INCLUDE 'MAPFFTZ.FCM'
	INTEGER SPACE
	INTEGER*2 FIRST(256)
C
C --- FILL UP OUR FIRST RECORD
      I1 = 100
      I2 = 100
      DO 100 I=1,3
         FIRST(I  ) = IOXYZ(I)
         FIRST(I+3) = IMXYZ(I)
         FIRST(I+6) = MYGRID(I)
         FIRST(I+9) = I1*CELL(I)
         FIRST(I+12)= I1*CELL(I+3)
  100    CONTINUE
      FIRST(16) = I2*PROD
      FIRST(17) =    PLUS
      FIRST(18) = I1
      FIRST(19) = I2
      DO 120 I=20,256
  120 FIRST(I) = 0
      INDXRA = INDXRA+1
	WRITE (6,11)(CELL(I),I=1,6)
11	FORMAT (/,2X,'CELL CONSTANTS BEING WRITTEN TO DSN6:',/,
	1       6F10.5)
      WRITE(LUN2'INDXRA)FIRST
	RETURN
	END
C=================================================================
	SUBROUTINE MAPIN(DOOPEN,ILEV,ngx,ngy,idir,I4)
	include 'mapfftZ.fcm'
	real title(20)
	logical doopen
	if (doopen) then
	 rewind lun1
      READ(LUN1,'(/I8)') NTITLE
      do j=1,ntitle 
      READ(LUN1,'(A)') 
      end do
         READ(LUN1,'(A)')
         READ(LUN1,'(A)')
         READ(LUN1,'(A)')
	 doopen = .FALSE.
	 ilev=0
	end if
	read(lun1,'(I8)',end=800)l
	if (l.eq.-256) goto 800
                         
	if (idir.eq.1) then
	 read(lun1,'(6E12.5)')(rho(j),j=1,i4)
	else
	 read(lun1,'(6E12.5)')(rhotmp(j),j=1,i4)
	 indx2 = 0
	 do inx=1,ngx
	  do iny=1,ngy
	   indx2 = indx2 + 1
	   indx1 = ngx * (iny-1) + inx
	   rho(indx2) = rhotmp(indx1)
	  end do
	 end do
	end if
	nrho = nrho + i4
	ilev=ilev + 1
	return
800	write (6,10)ilev
10	format(/,/,2x,'Error in MAPIN.. End of density file at ',
	1             'level : ',i7)
	stop
	end
C=================================================================	
