# 1 "help_to_html.f"
	program help_to_html
	implicit none


# 1 "file_data.inc"
	integer*4 CHR_LENG
	parameter (CHR_LENG = 256)
	common /file_data/ nlines, last_pointer, first_pointer,
     * line_length, line_point_to, line_point_from, file_lines
	integer*4 FILE_LINE_LENGTH
	parameter(  FILE_LINE_LENGTH = 4000 )
	integer*4 nlines, last_pointer, first_pointer
	character*(CHR_LENG) file_lines (FILE_LINE_LENGTH)
	integer*4  line_length(FILE_LINE_LENGTH),
     * line_point_to(FILE_LINE_LENGTH),
     * line_point_from(FILE_LINE_LENGTH)


# 5 "help_to_html.f"

	character*(CHR_LENG) line, line2, file_table, file_index, 
     * file_out, file_name, file_path, q_file_path
c	character*1 chr




	logical fverbatim, fitemize, fl_yes, fl_apost, file_is_open
	integer*4 inp, iout, ioutm, iout_tab, i, j, ii, nn, k,
     * iok, leng, level, last_line, ichr, nchr, nchr2, title_end,
     * parent(10), narg, length_file_table, length_file_out,
     * iln_start, iln_end, ifl_start, ifl_end, ifl_old, iii, 
     * length_file_index, length_file_path, length_q_file_path
	integer*4 ntable, table_of_cont(3,300), length_anchor(300),
     * nkeyword, keyword(3,500)
	character*(CHR_LENG) line_anchor(300)
	integer*4 iargc

	data inp, iout, ioutm, iout_tab /5, 9, 77, 10/






	narg = iargc()
c	write(ioutm,*) ' narg', narg
	file_out(1:6) = 'a.html'
	length_file_out = 6
	file_table(1:10) = 'a.toc_html'
	length_file_table = 10
	file_index(1:10) = 'a.ind_html'
	length_file_index = 10
	length_file_path = 0
	length_q_file_path = 0
	do i = 1, narg
	call getarg(i, line )
c	write(ioutm,*) 'line: {', line(1:10), '}', i

	if ( line(1:2) .eq. '-t' ) then
	ii = i + 1
	call getarg(ii, line )
	length_file_table = 0
	do j = 1, CHR_LENG
	if ( line(j:j) .le. ' ' ) goto 19
	file_table(j:j) = line(j:j)
	length_file_table = j
	end do
19	continue
	end if
c	write(ioutm,*) length_file_table, 
c     * 'table:  {', file_table(1:length_file_table), '}'

	if ( line(1:2) .eq. '-o' ) then
	ii = i + 1
	call getarg(ii, line )
	length_file_out = 0
	do j = 1, CHR_LENG
	if ( line(j:j) .le. ' ' ) goto 191
	file_out(j:j) = line(j:j)
	length_file_out = j
	end do
191	continue
	end if

c index file
	if ( line(1:2) .eq. '-x' ) then
	ii = i + 1
	call getarg(ii, line )
	length_file_index = 0
	do j = 1, CHR_LENG
	if ( line(j:j) .le. ' ' ) goto 192
	file_index(j:j) = line(j:j)
	length_file_index = j
	end do
192	continue
	end if
c	write(ioutm,*) length_file_index, 
c     * 'index:  {', file_index(1:length_file_index), '}'

c appended table of cont path index file
	if ( line(1:2) .eq. '-p' ) then
	ii = i + 1
	call getarg(ii, line )
	length_file_path = 0
	do j = 1, CHR_LENG
	if ( line(j:j) .le. ' ' ) goto 193
	file_path(j:j) = line(j:j)
	length_file_path = j
	end do
193	continue
	end if

c appended table of keyword index files
	if ( line(1:2) .eq. '-q' ) then
	ii = i + 1
	call getarg(ii, line )
	length_q_file_path = 0
	do j = 1, CHR_LENG
	if ( line(j:j) .le. ' ' ) goto 194
	q_file_path(j:j) = line(j:j)
	length_q_file_path = j
	end do
194	continue
	end if

	end do
c	write(*,*) 'length_file_path:', length_file_path

c	if ( length_file_path .gt. 0 ) write(*,*) length_file_path, 
c     * ' path: {', file_path(1:length_file_path), '}'

	do i = 1, FILE_LINE_LENGTH
	line_point_to(i) = -1
	line_point_from(i) = -1
	line_length(i) = -1
	end do

	nlines = 0
	first_pointer = 1
1	continue
	call rdline ( iok, inp, line, leng, level )
	if ( iok .ne. 0 ) goto 11
	nlines = nlines + 1
	line_length(nlines) = leng
	if ( leng .gt. 0 ) file_lines(nlines) (1:leng) = line(1:leng)
	if ( nlines .gt. 1 ) line_point_to(nlines-1) = nlines
	if ( nlines .gt. 0 ) line_point_from(nlines) = nlines-1
	goto 1
11	continue
	last_pointer = nlines
	last_line = nlines
	if ( nlines .le. 0 ) then
	write (ioutm,*)  ' %ERROR: EMPTY FILE'
	stop
	end if

c	write(ioutm,*) ' IN file consist of ',nlines, 
c     * first_pointer, last_pointer

c ---------------------------------------------

	call insert_line( iok, '<html>', 1 )
c	write(ioutm,*) ' IN file consist of ',nlines, 
c     * first_pointer, last_pointer

	nn = nlines
	call append_line( iok, '<head bgcolor="#4444bb">', nn )

	if ( line_length(1) .lt. 0 ) then
	write (ioutm,*) '%ERROR: THIS FILE CONTAINS NO TITLE LINE'
	title_end = nlines
	else
	nn = nlines
	call append_line( iok, '<title>', nn )
	ichr = -1
	do i = 2, line_length(1)
	if ( file_lines(1)(i-1:i-1) .eq. ' ' .and. 
     * file_lines(1)(i:i) .ne. ' ' ) then
	ichr = i
	goto 12
	end if
	end do
12	continue
c	write(ioutm,*) ' bef append:', nlines
	nchr = 0

	call putstr(iok, 'MAIN User`s guide:', line, nchr)




	call putstr(iok, file_lines(1)(ichr:line_length(1)), line, nchr)
	nn = nlines
c	line(1:line_length(1)-ichr+1) = file_lines(1)(ichr:line_length(1))
c	write(ioutm,*)' ichr: lentgh', ichr, line_length(i), ' {',
c     * line(1:line_length(i)-ichr+1), '}'
	call append_line( iok, line(1:nchr), nn )
c	write(ioutm,*) ' bef append /title:', nlines
	nn = nlines
	call append_line( iok, '</title>', nn )
	title_end = nlines
	nn = nlines
	call append_line( iok, '</head>', nn )
	end if

c

c start of the tex

	nn = nlines
	call append_line( iok, '<body>', nn )


	call append_line( iok, '</html>', last_line )
	call append_line( iok, '</body>', last_line )

c	write(ioutm,*) ' IN file consist of ',nlines, 
c     * first_pointer, last_pointer

c	call putstr( iok, '<head>', line, nchr )
c	call wrline( iok, iout, line, nchr, -5 )
c	call wrline ( iok, iout, '\include{head} ', 15, -5)


c paragraphs
	do 2 i = 1, last_line
	if ( line_point_to(i) .lt. 0 ) goto 2
	if ( line_length(i) .eq. 0 .and. 
     * line_length(line_point_to(i)) .gt. 0 )
     * then
	call append_line( iok, '<P>', i )
	end if
	if ( line_length(i) .gt. 0 .and. 
     * line_length(line_point_from(i)) .eq. 0 )
     * then
	call append_line( iok, '</P>', i )
	end if
2	continue

c	write(*,*) 'fverbatim'
c verbatim text
	fverbatim = .false.
	do 3 i = 2, last_line

c	if ( (file_lines(i)(1:1) .eq. '$' .and. 
c     * .not. file_lines(i)(1:2) .eq. '$\' )
	if ( file_lines(i)(1:1) .eq. '$' 
     * .or. file_lines(i)(1:1) .eq. '>' 
     * .or. file_lines(i)(1:3) .eq. '...' 
     * .or. file_lines(i)(1:5) .eq. 'MAIN>' 
     * .or. file_lines(i)(1:1) .eq. '*'
     * .or. file_lines(i)(1:1) .eq. char(9) 
     * .or. file_lines(i)(1:1) .eq. ' '
     * .or. file_lines(i-1)(3:8) .eq. 'Syntax' 
     * ) then
	if ( .not. fverbatim ) then
	call insert_line( iok, '<BLOCKQUOTE>', i )
	call insert_line( iok, '<PRE><FONT SIZE="-1">', i )
	fverbatim = .true.
	end if
	goto 3
	end if
	if ( fverbatim ) then
	call insert_line( iok, '</FONT></PRE>', i )
	nn = nlines
	call append_line( iok, '</BLOCKQUOTE>', nn )
	fverbatim = .false.
	end if
3	continue

c special characters - escape sequences 
	fl_apost = .false.
	ifl_old = -9999
	do 31 i = 1, last_line
c	   write(*,*) ' 3 i', i
	   file_is_open = .false.
	nchr = 0
	nchr2 = 0
	if ( line_length(i) .le. 0 ) goto 31
	j = 0
311	continue
	j = j + 1
	if ( j .gt.  line_length(i) ) goto 3119
c	do 311 j = 1, line_length(i)
	ii = j - 1
	if ( file_lines(i)(j:j) .eq. '<' ) then
	if ( ii .gt. nchr ) 
     * call putstr( iok, file_lines(i)(nchr+1:ii), line, nchr2 )
	nchr = j
	call putstr(iok, '&lt;', line, nchr2 )
	if ( file_lines(i)(j+1:j+1) .eq. ' ' ) then
	nchr2 = nchr2 + 1
	line(nchr2:nchr2) = ' '
	end if
	end if
	if ( file_lines(i)(j:j) .eq. '>' ) then
	if ( ii .gt. nchr ) 
     * call putstr( iok, file_lines(i)(nchr+1:ii), line, nchr2 )
	nchr = j
	call putstr(iok, '&gt;', line, nchr2 )
	if ( file_lines(i)(j+1:j+1) .eq. ' ' ) then
	nchr2 = nchr2 + 1
	line(nchr2:nchr2) = ' '
	end if
	end if
	if ( file_lines(i)(j:j) .eq. '&' ) then
	if ( ii .gt. nchr ) 
     * call putstr( iok, file_lines(i)(nchr+1:ii), line, nchr2 )
	nchr = j
	call putstr(iok, '&amp;', line, nchr2 )
	if ( file_lines(i)(j+1:j+1) .eq. ' ' ) then
	nchr2 = nchr2 + 1
	line(nchr2:nchr2) = ' '
	end if
	end if

	if ( file_lines(i)(j:j) .eq. '"' ) then
c	chr = file_lines(i)(j+1:j+1)
c	write(*,*) ' apostrophes', fl_apost, '{', 
c     * file_lines(i)(j+1:j+1), '}', ichar(file_lines(i)(j+1:j+1))
	if ( ii .gt. nchr ) 
     * call putstr( iok, file_lines(i)(nchr+1:ii), line, nchr2 )
	nchr = j
	if ( fl_apost ) then
	iln_end = nchr2
c	fl_apost = .false.
	ifl_end = j-1

	if ( ifl_old .eq. i .and. ifl_end .gt. ifl_start) then
c	write(*,*) 'file open {', file_lines(i)(ifl_start:ifl_end), '}'
	call file_com_open( iok, 66, file_lines(i)(ifl_start:ifl_end), 
     * file_name, leng )
	if ( iok .gt. 0 ) goto 312
	file_is_open = .true.
	nchr2 = iln_start
	call putstr( iok, '<A HREF = "', line, nchr2 )
c	write(*,*) ' ending>>>>>> {', file_name(leng-3:leng), '}'
	if ( leng .gt. 4 .and. 
     * file_name(leng-3:leng) .eq. '.txt' )then
	call putstr( iok, file_name(1:leng-4), line, nchr2 )
	call putstr( iok, '.html', line, nchr2 )
	else
	call putstr( iok, file_name(1:leng), line, nchr2 )
	end if
	call putstr(iok, '">', line, nchr2)
c	write(*,*) ' ending>>>>>> {', file_lines(i)(ifl_end-3:ifl_end), '}'
	if ( ifl_start + 4 .lt. ifl_end .and. 
     * file_lines(i)(ifl_end-3:ifl_end) .eq. '.txt' )then
	call putstr( iok, file_lines(i)(ifl_start:ifl_end-4), 
     * line, nchr2 )
	call putstr( iok, '.html', line, nchr2 )
	else
	call putstr( iok, file_lines(i)(ifl_start:ifl_end), line, nchr2 )
	end if
	call putstr(iok, '</A>', line, nchr2)
	goto 313
	end if
312	continue
	if ( leng .gt. 5 .and. ifl_end .gt. 5 .and.
     * file_lines(i)(ifl_end-4:ifl_end) .eq. '.html' .or. 
     * file_lines(i)(ifl_start:ifl_start+4) .eq. 'http:' .or. 
     * file_lines(i)(ifl_start:ifl_start+4) .eq. 'HTTP:' 
     * )then
	nchr2 = iln_start
	call putstr( iok, '<A HREF = "', line, nchr2 )
	call putstr( iok, file_lines(i)(ifl_start:ifl_end), line, nchr2 )
	call putstr(iok, '">', line, nchr2)
	call putstr( iok, file_lines(i)(ifl_start:ifl_end), line, nchr2 )
	call putstr(iok, '</A>', line, nchr2)
	end if

313	continue

	if ( fl_apost ) then
c	   write(*,*) ' fl_apost: put a "'
	if ( file_is_open ) then
	call putstr(iok, '</STRONG>', line, nchr2 )
	else
	call putstr(iok, '"</STRONG>', line, nchr2 )
	end if
	fl_apost = .false.
	end if



c	write(*,*) 'i, j', i, j
c	j = j + 1
	if ( file_lines(i)(j+1:j+1) .eq. ' ' ) then
c	write(*,*) ' insert blank'
	nchr2 = nchr2 + 1
	line(nchr2:nchr2) = ' '
	end if

	else
	ifl_start = j+1
	ifl_old = i
	if ( j .gt. 1 .and. file_lines(i)(j-1:j-1) .eq. ' ' ) then
c	write(*,*) ' add blank'
	nchr2 = nchr2 + 1
	line(nchr2:nchr2) = ' '
	end if

	iln_start = nchr2
	call putstr(iok, '<STRONG>"', line, nchr2 )
	fl_apost = .true.


	end if
	end if

	goto 311
3119	continue

c apostrophes should not extend into the next paragraph

	if ( fl_apost .and. line_length(i+1) .le. 0 ) then
	if ( ii .gt. nchr ) 
     * call putstr( iok, file_lines(i)(nchr+1:ii), line, nchr2 )
c	   write(*,*) ' fl_apost: 3119 put a "'
	call putstr(iok, '"</STRONG>', line, nchr2 )
	fl_apost = .false.
	end if

	if ( nchr2 .gt. 0 ) then
	if ( nchr .lt. line_length(i) ) 
     * call putstr(iok, file_lines(i)(nchr+1:line_length(i)), line, 
     * nchr2 )
	file_lines(i)(1:nchr2) = line(1:nchr2)
	line_length(i) = nchr2
	end if
31	continue

c file data
	do i = 1, 6
	if ( file_lines(i)(1:5) .eq. 'File:' ) then
	call putstr(iok, '<BR>', file_lines(i), line_length(i))
	line_point_to(line_point_from(i)) = line_point_to(i)
	line_point_from(line_point_to(i)) = line_point_from(i)
	line_point_from(line_point_to(title_end)) = i
	line_point_to(i) = line_point_to(title_end)
	line_point_to(title_end) = i
	line_point_from(i) = title_end
	title_end = i
	goto 21
	end if
	end do
21	continue
	do i = 1, 6
	if ( file_lines(i)(1:14) .eq. 'Last modified:' ) then
	call putstr(iok, '<BR>', file_lines(i), line_length(i))
	line_point_to(line_point_from(i)) = line_point_to(i)
	line_point_from(line_point_to(i)) = line_point_from(i)
	line_point_from(line_point_to(title_end)) = i
	line_point_to(i) = line_point_to(title_end)
	line_point_to(title_end) = i
	line_point_from(i) = title_end
	goto 22
	end if
	end do
22	continue

c sections
c	write(*,*) 'sections'
	ntable = 0
	nkeyword = 0
	parent(1) = 1
	i = 0
4	continue
	i = i + 1
	if ( i .gt. last_line ) goto 41
	if ( line_length(i) .le. 0 ) goto 4















	k = 0
	level = -1
401	continue
	k = k + 1
	if ( k .gt. line_length(i) ) goto 4
	if ( file_lines(i)(k:k) .lt. '0' .or. 
     * file_lines(i)(k:k) .gt. '9' ) goto 4
	k = k + 1
	if ( file_lines(i)(k:k) .ne. '.' ) then
	if ( file_lines(i)(k:k) .lt. '0' .or. 
     * file_lines(i)(k:k) .gt. '9' ) goto 4
	k = k + 1
	if ( file_lines(i)(k:k) .ne. '.' ) goto 4
	end if
	level = level + 1
	if ( file_lines(i)(k+1:k+1) .ne. ' ' ) goto 401
	ichr = k+2

	file_lines(i)(1:line_length(i)-ichr+1) =
     * file_lines(i)(ichr:line_length(i)) 
	line_length(i) = line_length(i)-ichr+1

	ntable = ntable + 1
	table_of_cont(1,ntable) = level
	table_of_cont(2,ntable) = i


	length_anchor(ntable) = 0
	call gen_anchor(iok, file_lines(i)(1:line_length(i)), 
     * line_anchor(ntable), length_anchor(ntable) )
c	write(*,*) '{', line_anchor(ntable)(1:length_anchor(ntable) ), 
c     * '}', length_anchor(ntable)














	
c	write(ioutm,*) 'ntable:', ntable, ' {', 
c     * file_lines(i)(1:line_length(i)), '}'
c	if ( level .eq.  1 ) then
c	table_of_cont(3,ntable) = 0
c	parent(level) = ntable
c	end if
c	if ( level - 1 .eq. table_of_cont(1,parent(level))) then
c	table_of_cont(3,ntable) = parent(level)
c	end if
c	if ( level - 1 .gt. table_of_cont(1,parent(level))) then
c	parent(level) = ntable - 1 
c	table_of_cont(3,ntable) = parent(level)
c	end if
	if ( line_length(i+1) .le. 0 ) goto 4
	i = i + 1
	if ( file_lines(i)(1:8) .ne. 'Keyword:' ) goto 4
	nkeyword = nkeyword + 1
	keyword(1,nkeyword) = i
	keyword(2,nkeyword) = ntable
	keyword(3,nkeyword) = table_of_cont(2,ntable)
c	write(*,*) ' keyword 1-2-3', i, ntable, table_of_cont(2,ntable)
	call exclude_line(i)
	goto 4
41	continue
	

c	write(ioutm,*) ' ntable ', ntable
	if ( ntable .le. 0 ) goto 59
c	do 50 ii = 1, ntable
c	i = table_of_cont(2,ii)
c50	continue

c	write(*,*) ' bef toc file', length_file_table
	
	call file_open( iok, iout, file_table(1:length_file_table))
c	write(*,*) ' aft toc file', length_file_table
	if ( iok .ne. 0 ) call exit
	if ( length_file_table .le. 0 ) then
	write(*,*) 
     * '%ERROR: zero length for the table of contents file name'
c	call exit
	end if



	level = 0
	do ii = 1, ntable
	i = table_of_cont(2,ii)

	if ( table_of_cont(1,ii) .gt. level ) then
	nchr2 = 0
	call putstr(iok, '<UL>', line2, nchr2)
	call wrline(iok, iout, line2, nchr2, 0 )
	end if

	if ( table_of_cont(1,ii) .lt. level ) then
	nchr2 = 0
	do j = table_of_cont(1,ii), level-1
	call putstr(iok, '</UL>', line2, nchr2)
	end do
	call wrline(iok, iout, line2, nchr2, 0 )
	end if

	level = table_of_cont(1,ii)

	nchr2 = 0
	call putstr(iok, '<LI><A HREF = "', line2, nchr2)
	if ( length_file_path .gt. 0 ) 
     * call putstr(iok, file_path(1:length_file_path), line2, nchr2)
	call putstr(iok, file_out(1:length_file_out), line2, nchr2)
	call putstr(iok, '#', line2, nchr2)
c	write(ioutm,*) 'toc ii len_anch', ii, length_anchor(ii), nchr2
c	call wrline(iok, 6, file_lines(i), line_length(i), 0 )
c	call wrline(iok, 6, line_anchor(ii), length_anchor(ii), 0 )
	call putstr(iok, line_anchor(ii)(1:length_anchor(ii)), line2, 
     * nchr2)
	call putstr(iok, '">', line2, nchr2)
	call putstr(iok, file_lines(i)(1:line_length(i)), line2, nchr2)
	call putstr(iok, '</A>', line2, nchr2)
	call wrline(iok, iout, line2, nchr2, 0 )

	end do

	if ( level .ge. 1 ) then
	nchr2 = 0
	do j = 1, level
	call putstr(iok, '</UL>', line2, nchr2)
	end do
	call wrline(iok, iout, line2, nchr2, 0 )
	end if

	close ( unit = iout )	

c INDEX file
c	write(*,*) ' bef toc file', length_file_table
	if ( nkeyword .gt. 0 ) then
	call file_open( iok, iout, file_index(1:length_file_index))
c	write(*,*) ' aft toc file', length_file_index
	if ( iok .ne. 0 ) call exit
	if ( length_file_index .le. 0 ) then
	write(*,*) 
     * '%ERROR: zero length for the table of contents file name'
c	call exit
	end if

	level = 0
	do 480 iii = 1, nkeyword
	i  = keyword(1,iii)
	ii = keyword(2,iii)
c	write(*,*) ' keyword loop', iii,  (keyword(k,iii), k=1,3)
	j = 9
	nchr2 = 0
48	continue
	j = j + 1
	if ( j .gt. line_length(i) ) goto 481
	if ( file_lines(i)(j:j) .ne. ',' ) then
	nchr2 = nchr2  + 1
	line2(nchr2:nchr2) = file_lines(i)(j:j)
	goto 48
	end if
	
481	continue
	j = j + 1
	if ( file_lines(i)(j+1:j+1) .eq. ' ' ) goto 481
	nchr2 = nchr2 + 1	
	line2(nchr2:nchr2) = ' '

	call putstr(iok, '<A HREF = "', line2, nchr2)
	if ( length_q_file_path .gt. 0 ) 
     * call putstr(iok, q_file_path(1:length_q_file_path), line2, nchr2)
	call putstr(iok, file_out(1:length_file_out), line2, nchr2)
	call putstr(iok, '#', line2, nchr2)
	call putstr(iok, line_anchor(ii)(1:length_anchor(ii)), line2, 
     * nchr2)
	call putstr(iok, '">', line2, nchr2)
	call putstr(iok, file_lines(keyword(3,iii))
     * (1:line_length(keyword(3,iii))), line2, nchr2)
	call putstr(iok, '</A>', line2, nchr2)
	call wrline(iok, iout, line2, nchr2, 0 )
	nchr2 = 0
	if ( j + 1 .gt. line_length(i) ) goto 480
	goto 48
480	continue

	close ( unit = iout )	
	end if


	do 51 j = 1, ntable
c	write(ioutm,*) ' ntable j-loop', j
	level = table_of_cont(1,j)
	title_end = table_of_cont(2,j)
c	write(ioutm,*) ' 51 j tables:', j, level, title_end, 
c     * ' {', file_lines(title_end)(1:line_length(title_end)), '}'
	fl_yes = .true.
	do 52 ii = j+1, ntable
c	write(ioutm,*) ' 52 ii tables:', ii, level
c	write(ioutm,*) 'TABLE OF:', ii,  (table_of_cont(k,ii),k=1,2)
	if ( table_of_cont(1,ii) .le. table_of_cont(1,j) ) goto 521

c the high line

c	if ( fl_yes ) then
c	i = table_of_cont(2,j)
c	nchr = 0
cc	call putstr(iok, '<LI>', line, nchr)
c	call putstr(iok, '<A HREF = "#', line, nchr)
c
cc	write(ioutm,*)'length_anchor(j)', j, length_anchor(j)
c	call putstr(iok, line_anchor(j)(1:length_anchor(j)), line, nchr)
c	call putstr(iok, '">', line, nchr)
c	call putstr(iok, file_lines(i)(1:line_length(i)), line, nchr)
c	call putstr(iok, '</A>', line, nchr)

c	title_end = table_of_cont(2,j)
cc	call append_line(iok, line(1:nchr), title_end )
c	title_end = nlines
cc	title_end = table_of_cont(2,j)
cc	write(ioutm,*) ' 51 j froms:', j, level, title_end, 
cc     * ' {', file_lines(title_end)(1:line_length(title_end)), '}'

cc	call append_line(iok, '<UL>', title_end )
cc	title_end = nlines
c	end if

	if (table_of_cont(1,ii) .gt. level ) then
c	title_end = line_point_to(table_of_cont(2,ii))
	call append_line(iok, '<UL>', title_end )
	title_end = nlines
	end if

c closing levels

	if (table_of_cont(1,ii) .lt. level ) then
	do k = table_of_cont(1,ii), level-1
	call append_line(iok, '</UL>', title_end )
	title_end = nlines
	end do
	end if


	fl_yes = .false.
	nchr = 0
	call putstr(iok, '<LI>', line, nchr)
	call putstr(iok, '<A HREF = "#', line, nchr)
	i = table_of_cont(2,ii)
	call putstr(iok, line_anchor(ii)(1:length_anchor(ii)), line, nchr)
	call putstr(iok, '">', line, nchr)
	call putstr(iok, file_lines(i)(1:line_length(i)), line, nchr)
	call putstr(iok, '</A>', line, nchr)

	call append_line(iok, line(1:nchr), title_end )
	title_end = nlines
	level = table_of_cont(1,ii)
52	continue
521	continue
	do k = table_of_cont(1,j), level-1
	title_end = nlines
	call append_line(iok, '</UL>', title_end )
	end do

51	continue

c create titles and their anchors

	do 53 ii = 1, ntable
	i =  table_of_cont(2,ii)
	nchr = 0
	call putstr(iok, '<A NAME = "', line, nchr)
c	write(ioutm,*) 'ii', ii
c	write(ioutm,*) 'length', length_anchor(ii)
	call putstr(iok, line_anchor(ii)(1:length_anchor(ii)), line, nchr)
	call putstr(iok, '">', line, nchr)
	call putstr(iok, file_lines(i)(1:line_length(i)), line, nchr)
	call putstr(iok, '</A>', line, nchr)

	file_lines(i)(1:nchr) = line(1:nchr)
	line_length(i) = nchr
	goto( 531, 532, 533, 534, 535, 535, 535, 535, 535 ) 
     * table_of_cont(1,ii)
531	continue
	call insert_line(iok, '<P><STRONG><FONT COLOR="#e61010"><H1>', i )
	call append_line(iok, '</H1></FONT></STRONG></P>', i )
	goto 530
532	continue
	call insert_line(iok, '<P><STRONG><FONT COLOR="#e41310"><H2>', i )
	call append_line(iok, '</H2></FONT></STRONG></P>', i )
	goto 530
533	continue
	call insert_line(iok, '<P><STRONG><FONT COLOR="#e21510"><H3>', i )
	call append_line(iok, '</H3></FONT></STRONG></P>', i )
	goto 530
534	continue
	call insert_line(iok, '<P><STRONG><FONT COLOR="#e11710"><H4>', i )
	call append_line(iok, '</H4></FONT></STRONG></P>', i )
	goto 530
535	continue
	call insert_line(iok, '<P><STRONG><FONT COLOR="#e01020"><H5>', i )
	call append_line(iok, '</H5></FONT></STRONG></P>', i )
	goto 530
530	continue

53	continue

59	continue

c	write(*,*) 'after 59'

	fitemize = .false.
	do 6 i = 1, last_line
	if ( file_lines(i)(1:2) .eq. '- ' .and. .not. fitemize ) then
	fitemize = .true.
	nn = i
	call insert_line( iok, '<UL>', nn )
	end if
	if ( file_lines(i)(1:2) .eq. '- ' ) then
	nn = i
	call insert_line( iok, '<LI>', nn )
	file_lines(i)(1:line_length(i)-2) = 
     * file_lines(i)(3:line_length(i))
	line_length(i) = line_length(i) - 2
	end if
	if ( fitemize .and. line_length(i+1) .le. 0 ) then
	nn = i
	call append_line( iok, '</UL>', nn )
	fitemize = .false.
	end if
6	continue

# 934 "help_to_html.f"


c write the file

c	write(*,*) ' bef wr file'
	call file_open( iok, iout, file_out(1:length_file_out))
c	write(*,*) ' aft open file', iok
	if ( iok .eq. 0 ) then
	ii = first_pointer
90	continue	
c	write(*,*) ' ii', ii, ' to:', line_point_to(ii), 
c     * ' fr:', line_point_from(ii)
	call wrline(iok, iout, file_lines(ii), line_length(ii), -5 )
	ii = line_point_to(ii)
	if ( ii .ne. last_pointer ) goto 90
c	write(*,*) ' ii', ii, ' to:', line_point_to(ii), 
c     * ' fr:', line_point_from(ii)
	call wrline(iok, iout, file_lines(ii), line_length(ii), -5 )
	close ( unit = iout )	
	end if

	stop 
	end
c
c ----------------------------------------
c
c reads a line of text from unit iu
c
	subroutine rdline ( iok, iu, line, leng, level )
	implicit none

# 1 "file_data.inc"
	integer*4 CHR_LENG
	parameter (CHR_LENG = 256)
	common /file_data/ nlines, last_pointer, first_pointer,
     * line_length, line_point_to, line_point_from, file_lines
	integer*4 FILE_LINE_LENGTH
	parameter(  FILE_LINE_LENGTH = 4000 )
	integer*4 nlines, last_pointer, first_pointer
	character*(CHR_LENG) file_lines (FILE_LINE_LENGTH)
	integer*4  line_length(FILE_LINE_LENGTH),
     * line_point_to(FILE_LINE_LENGTH),
     * line_point_from(FILE_LINE_LENGTH)


# 965 "help_to_html.f"
	integer*4 iok, iu, leng, level
	character*(CHR_LENG) line

	integer*4 j, i
10	continue
	leng = 0
	iok = 0
	read ( iu, 1, end=200, err=100 ) (line(j:j),j=1,CHR_LENG)
1	format( 300a1 )
	do 2 i = CHR_LENG,1,-1
	if ( line(i:i) .eq. ' ' ) goto 2
	leng = i
	goto 20
2	continue
c	if ( leng .le. 0 ) goto 10
	return
20	continue
c	ileng = leng
c	do 3 i = 1, ileng
c	if ( line(i:i) .ne. '!' ) goto 3
c	leng = i-1
c	if ( leng .le. 0 ) goto 10
c	return
c3	continue
	return
c error
100	continue
	iok = 1
	return
c end of file
200	continue
	iok = -1
	return
	end
c
c ----------------------------------------
c
c writes a line of text to unit iu
c
	subroutine wrline ( iok, iun, line, leng, level )
	implicit none
	integer*4 iok, iun, leng, level
	character*(*) line
	integer*4 j
	iok = 0
	write ( iun, 1, err=100 ) (line(j:j),j=1,leng)
1	format( 500a1 )
	return
100	continue
	iok = 1
	return
	end
c
	subroutine mkline( ioutm,  current_line, lnlines, line, leng )

# 1 "file_data.inc"
	integer*4 CHR_LENG
	parameter (CHR_LENG = 256)
	common /file_data/ nlines, last_pointer, first_pointer,
     * line_length, line_point_to, line_point_from, file_lines
	integer*4 FILE_LINE_LENGTH
	parameter(  FILE_LINE_LENGTH = 4000 )
	integer*4 nlines, last_pointer, first_pointer
	character*(CHR_LENG) file_lines (FILE_LINE_LENGTH)
	integer*4  line_length(FILE_LINE_LENGTH),
     * line_point_to(FILE_LINE_LENGTH),
     * line_point_from(FILE_LINE_LENGTH)


# 1020 "help_to_html.f"
	character*(CHR_LENG) current_line
# 1202 "help_to_html.f"

	return
	end
c
c fill the tabs
c
	subroutine mkvline( current_line, lnlines, line, leng )
	implicit none
	integer*4 lnlines, leng
	character*(*) current_line, line
	integer*4 k, k1, i1, j
c insert backslash
	leng = lnlines
	if ( lnlines .le. 0 ) return
	k = 0
	k1 = 0
1	continue
	k = k + 1
	if ( k .gt. lnlines ) goto 2
	k1 = k1 + 1
	if ( current_line(k:k) .eq. char(9) ) then
	line(k1:k1) = ' '
	i1 = mod( k1, 8 )
	if ( i1 .le. 0 ) goto 1
	do 10 j = i1, 7
	k1 = k1 + 1
	line(k1:k1) = ' '
10	continue
	else
	line(k1:k1) = current_line(k:k)
	end if
	goto 1
2	continue
	leng = k1
	return
	end
c
c puts a string into the alternate command input string  comin
c
	subroutine putstr (iok, string, line, nc )
	implicit none
	integer*4 iok, nc
	character*(*) string
	character*(*) line
 
	integer*4 leng, k, ibg, last, mlength
 
	iok = 0
	leng = len(string)
	mlength = len(line)
	do 1 k = 1, leng
	if ( string(k:k) .eq. ' ' ) goto 1
	ibg = k
	goto 10
1	continue
	goto 100
10	continue
	do 2 k = leng, ibg, -1
	if ( string(k:k) .eq. ' ' ) goto 2
	last = k
	goto 20
2	continue
	goto 100
20	continue
	do 3 k = ibg, last
	if ( nc .ge. mlength ) goto 100
	nc = nc + 1
	line(nc:nc) = string(k:k)
3	continue
	if ( nc .ge. mlength ) return
c	nc = nc + 1
c	line(nc:nc) = ' '
	return
100	continue
	iok = 1
	return
	end

c
c write an integer into string 
c
	subroutine write_inte_to_str (iok, inte, leng, strform, line, nc )
	implicit none

# 1 "file_data.inc"
	integer*4 CHR_LENG
	parameter (CHR_LENG = 256)
	common /file_data/ nlines, last_pointer, first_pointer,
     * line_length, line_point_to, line_point_from, file_lines
	integer*4 FILE_LINE_LENGTH
	parameter(  FILE_LINE_LENGTH = 4000 )
	integer*4 nlines, last_pointer, first_pointer
	character*(CHR_LENG) file_lines (FILE_LINE_LENGTH)
	integer*4  line_length(FILE_LINE_LENGTH),
     * line_point_to(FILE_LINE_LENGTH),
     * line_point_from(FILE_LINE_LENGTH)


# 1286 "help_to_html.f"
	integer*4 iok, inte, leng, nc
	character*(*) strform
	character*(CHR_LENG) line
 
	integer*4 k, ibg
	character*12 chr12

	if ( leng .le. 0 ) goto 2
	if ( nc + leng .gt. CHR_LENG ) goto 100
	write(line(nc+1:nc+leng), strform, err=100 ) inte
	nc = nc + leng
	if ( nc .ge. CHR_LENG ) return
c	nc = nc + 1
c	line(nc:nc) = ' '
	return
2	continue

	write(chr12, '(i12)', err=100 ) inte

	do 1 k = 1, 12
	if ( chr12(k:k) .eq. ' ' ) goto 1
	ibg = k
	goto 10
1	continue
	goto 100
10	continue

	do 3 k = ibg, 12
	if ( nc .ge. CHR_LENG ) goto 100
	nc = nc + 1
	line(nc:nc) = chr12(k:k)
3	continue
	if ( nc .ge. CHR_LENG ) return
c	nc = nc + 1
c	line(nc:nc) = ' '
	return
100	continue
	iok = 1
	return
	end
 
c
c write an integer into string 
c
	subroutine write_real_to_str (iok, rreal, leng, strform, 
     * line, nc )
	implicit none

# 1 "file_data.inc"
	integer*4 CHR_LENG
	parameter (CHR_LENG = 256)
	common /file_data/ nlines, last_pointer, first_pointer,
     * line_length, line_point_to, line_point_from, file_lines
	integer*4 FILE_LINE_LENGTH
	parameter(  FILE_LINE_LENGTH = 4000 )
	integer*4 nlines, last_pointer, first_pointer
	character*(CHR_LENG) file_lines (FILE_LINE_LENGTH)
	integer*4  line_length(FILE_LINE_LENGTH),
     * line_point_to(FILE_LINE_LENGTH),
     * line_point_from(FILE_LINE_LENGTH)


# 1334 "help_to_html.f"
	integer*4 iok
	real*4 rreal
	integer*4 leng, nc
	character*(*) strform
	character*(CHR_LENG) line
 
	integer*4 k, ibg
	character*80 chr80

	if ( leng .le. 0 ) goto 2
	if ( nc + leng .gt. CHR_LENG ) goto 100
	write(line(nc+1:nc+leng), strform, err=100 ) rreal
	nc = nc + leng
	if ( nc .ge. CHR_LENG ) return
	nc = nc + 1
	line(nc:nc) = ' '
	return
2	continue

	write(chr80, strform, err=100 ) rreal
	do 21 k = 80, 1, -1
	if ( chr80(k:k) .ne. ' ' ) goto 21
	ibg = k
	goto 210
21	continue
	goto 100
210	continue

	if ( nc + 80 - ibg .ge. CHR_LENG ) goto 100
	do 3 k = ibg, 80
	nc = nc + 1
	line(nc:nc) = chr80(k:k)
3	continue
	if ( nc .ge. CHR_LENG ) return
	nc = nc + 1
	line(nc:nc) = ' '
	return
100	continue
	iok = 1
	return
	end


	subroutine insert_line( iok, string, ii )
	implicit none
	integer*4 iok, ii
	character*(*) string
	

# 1 "file_data.inc"
	integer*4 CHR_LENG
	parameter (CHR_LENG = 256)
	common /file_data/ nlines, last_pointer, first_pointer,
     * line_length, line_point_to, line_point_from, file_lines
	integer*4 FILE_LINE_LENGTH
	parameter(  FILE_LINE_LENGTH = 4000 )
	integer*4 nlines, last_pointer, first_pointer
	character*(CHR_LENG) file_lines (FILE_LINE_LENGTH)
	integer*4  line_length(FILE_LINE_LENGTH),
     * line_point_to(FILE_LINE_LENGTH),
     * line_point_from(FILE_LINE_LENGTH)


# 1383 "help_to_html.f"

	integer*4 str_length
	str_length = len(string)

	nlines = nlines + 1
	file_lines(nlines)(1:str_length) = string(1:str_length)
	line_length(nlines) = str_length

	line_point_from(nlines) = line_point_from(ii)

	if ( line_point_from(ii) .gt. 0 ) then
	line_point_to(line_point_from(ii)) = nlines
	end if
	line_point_to(nlines) = ii
	line_point_from(ii)= nlines
	if ( ii .eq. first_pointer ) first_pointer = nlines

	return
	end

	subroutine exclude_line( ii )
	implicit none
	integer*4 ii
	

# 1 "file_data.inc"
	integer*4 CHR_LENG
	parameter (CHR_LENG = 256)
	common /file_data/ nlines, last_pointer, first_pointer,
     * line_length, line_point_to, line_point_from, file_lines
	integer*4 FILE_LINE_LENGTH
	parameter(  FILE_LINE_LENGTH = 4000 )
	integer*4 nlines, last_pointer, first_pointer
	character*(CHR_LENG) file_lines (FILE_LINE_LENGTH)
	integer*4  line_length(FILE_LINE_LENGTH),
     * line_point_to(FILE_LINE_LENGTH),
     * line_point_from(FILE_LINE_LENGTH)


# 1408 "help_to_html.f"

	line_point_to(line_point_from(ii)) = line_point_to(ii)
	line_point_from(line_point_to(ii)) = line_point_from(ii)
	line_point_to(ii) = 0
	line_point_from(ii) = 0

	return
	end

	subroutine append_line( iok, string, ii )
	implicit none
	integer*4 iok, ii
	character*(*) string
	

# 1 "file_data.inc"
	integer*4 CHR_LENG
	parameter (CHR_LENG = 256)
	common /file_data/ nlines, last_pointer, first_pointer,
     * line_length, line_point_to, line_point_from, file_lines
	integer*4 FILE_LINE_LENGTH
	parameter(  FILE_LINE_LENGTH = 4000 )
	integer*4 nlines, last_pointer, first_pointer
	character*(CHR_LENG) file_lines (FILE_LINE_LENGTH)
	integer*4  line_length(FILE_LINE_LENGTH),
     * line_point_to(FILE_LINE_LENGTH),
     * line_point_from(FILE_LINE_LENGTH)


# 1423 "help_to_html.f"

	integer*4 str_length
	str_length = len(string)

	nlines = nlines + 1
	file_lines(nlines)(1:str_length) = string(1:str_length)
	line_length(nlines) = str_length

	if ( line_point_to(ii) .gt. 0 ) then
	line_point_to(nlines) = line_point_to(ii)
	line_point_from(line_point_to(ii)) = nlines
	end if


	line_point_to(ii) = nlines
	line_point_from(nlines)= ii


	if ( ii .eq. last_pointer ) last_pointer = nlines

	return
	end

	subroutine gen_anchor( iok, string, line, nchr )
	implicit none

# 1 "file_data.inc"
	integer*4 CHR_LENG
	parameter (CHR_LENG = 256)
	common /file_data/ nlines, last_pointer, first_pointer,
     * line_length, line_point_to, line_point_from, file_lines
	integer*4 FILE_LINE_LENGTH
	parameter(  FILE_LINE_LENGTH = 4000 )
	integer*4 nlines, last_pointer, first_pointer
	character*(CHR_LENG) file_lines (FILE_LINE_LENGTH)
	integer*4  line_length(FILE_LINE_LENGTH),
     * line_point_to(FILE_LINE_LENGTH),
     * line_point_from(FILE_LINE_LENGTH)


# 1449 "help_to_html.f"
	integer*4 iok
	character*(*) string
	character*(CHR_LENG) line
	integer*4 nchr
	logical flag
	integer*4 i, str_length

	str_length = len(string)
c	write(7,*) 'ANCHOR IN {', string(1:str_length), '}', str_length
	nchr = 1
	flag = .false.
	line(1:1) = string(1:1)
	do 1 i = 2, str_length
	if ( string(i:i) .eq. ' ' ) then
	flag = .true.
	else
	if ( flag ) then
	nchr = nchr + 1
	line(nchr:nchr) = string(i:i)
	end if
	flag = .false.
	end if
1	continue
c	write(7,*) 'ANCHOR out {', line(1:nchr), '}', nchr
	return
	end

	subroutine gen_help_anchor(iok, level, parent, line, nchr )
	implicit none

# 1 "file_data.inc"
	integer*4 CHR_LENG
	parameter (CHR_LENG = 256)
	common /file_data/ nlines, last_pointer, first_pointer,
     * line_length, line_point_to, line_point_from, file_lines
	integer*4 FILE_LINE_LENGTH
	parameter(  FILE_LINE_LENGTH = 4000 )
	integer*4 nlines, last_pointer, first_pointer
	character*(CHR_LENG) file_lines (FILE_LINE_LENGTH)
	integer*4  line_length(FILE_LINE_LENGTH),
     * line_point_to(FILE_LINE_LENGTH),
     * line_point_from(FILE_LINE_LENGTH)


# 1479 "help_to_html.f"
	integer*4 iok, level
	character*10 parent(level)
	character*(CHR_LENG) line
	integer*4 nchr
	integer*4 i, j, ii

	iok = 0
	nchr = 0
	do 1 i = 1, level
	ii = i
	call write_inte_to_str (iok, ii, 1, '(i1)', line, nchr )
	do 11 j = 1, 10
	if ( 
     * parent(i)(j:j) .eq. 'A' .or. parent(i)(j:j) .eq. 'a' .or. 
     * parent(i)(j:j) .eq. 'E' .or. parent(i)(j:j) .eq. 'e' .or. 
     * parent(i)(j:j) .eq. 'I' .or. parent(i)(j:j) .eq. 'i' .or. 
     * parent(i)(j:j) .eq. 'O' .or. parent(i)(j:j) .eq. 'o' .or. 
     * parent(i)(j:j) .eq. 'U' .or. parent(i)(j:j) .eq. 'u' .or. 
     * parent(i)(j:j) .le. ' ' 
     & ) goto 11
	call putstr( iok, parent(i)(j:j), line, nchr )
11	continue
c	write(*,*) ' level i ', i, nchr, ' {', line(1:nchr), '}'
1	continue

	return
	end

	subroutine file_open( iok, iu, string)
	implicit none
	integer*4 iok, iu
	character*(*) string
	integer*4 length
	length = len(string)
	iok = 1
	open ( unit = iu, file = string(1:length),
     * status = 'unknown', err = 100 )
	rewind ( unit = iu )
	iok = 0
	return
100	continue
	write(7,*) 'FILE OPEN %ERROR: {', string(1:length), '}'
	return
	end

	subroutine file_com_open(iok, iu, str_in, str_out, last )
	implicit none
	integer*4 iok, iu, last

# 1 "file_data.inc"
	integer*4 CHR_LENG
	parameter (CHR_LENG = 256)
	common /file_data/ nlines, last_pointer, first_pointer,
     * line_length, line_point_to, line_point_from, file_lines
	integer*4 FILE_LINE_LENGTH
	parameter(  FILE_LINE_LENGTH = 4000 )
	integer*4 nlines, last_pointer, first_pointer
	character*(CHR_LENG) file_lines (FILE_LINE_LENGTH)
	integer*4  line_length(FILE_LINE_LENGTH),
     * line_point_to(FILE_LINE_LENGTH),
     * line_point_from(FILE_LINE_LENGTH)


# 1528 "help_to_html.f"
	character*(*) str_in, str_out
	character*(CHR_LENG) string, string_env, env_out
	integer*4 leng, leng2, leng0, i, leng_env

	leng = len (str_in)
c	write(*,*) 'leng strin', leng, str_in(1:leng)
	last = 0
	if (  leng .ge. 1 .and. str_in(1:1) .eq. '>' ) then
	leng0 = 2 - 1
	leng_env = 4
	string_env(1:4) = 'MAIN'
	goto 9
	end if
	if (  leng .ge. 2 .and. str_in(1:2) .eq. '?>' ) then
	leng0 = 3 - 1
	leng_env = 4
	string_env(1:4) = 'MAIN'
	goto 9
	end if

	if ( leng .ge. 2 .and. str_in(1:2) .eq. '<>' ) then
	leng0 = 3 - 1
	leng_env = 4
	string_env(1:4) = 'MAIN'
	goto 9
	end if

	if ( leng .ge. 3 ) then
	if ( str_in(1:3) .eq. '<?>' ) then
	leng0 = 4 - 1
	leng_env = 4
	string_env(1:4) = 'MAIN'
	goto 9
	end if
	end if

	if (  leng .ge. 3 ) then
	if (  str_in(1:3) .eq. '< >' ) then
	leng0 = 4 - 1
	leng_env = 4
	string_env(1:4) = 'MAIN'
	goto 9
	end if
	end if

	if (  leng .ge. 2 .and. str_in(1:1) .eq. '?' ) then
	leng_env = 0
	do 11 i = 3, leng
	if ( str_in(i:i) .ne. ':' ) goto 11
	leng0 = i + 1
	string_env(1:i-2) = str_in(2:i-1)
	leng_env = i-2
	goto 9
11	continue
	string(1:leng-1) = str_in(2:leng)
	last = leng-1
	else
	leng_env = 0
	do 1 i = 2, leng
	if ( str_in(i:i) .ne. ':' ) goto 1
	leng0 = i 
	string_env(1:i-1) = str_in(1:i-1)
	leng_env = i-1
	goto 9
1	continue
c	write(*,*) 'leng', leng, str_in(1:leng)
	if ( leng .gt. 0 ) string(1:leng) = str_in(1:leng)
	last = leng
	end if

	goto 91
9	continue
	call get_environment( leng_env, string_env(1:leng_env), 
     * leng2, env_out)
c	write(*,*) 'get_env:', string_env(1:leng_env), leng_env
c	write(*,*) 'get_env 2:', leng2
c	if ( leng2 .gt. 0 ) write(*,*) 'get_env 3:', env_out(1:leng2)
	if ( leng2 .le. 0 .or. leng0 .gt. leng .or. 
     * (leng2 .eq. 2 .and. env_out(1:2) .eq. './' ) )then
	string(1:leng) = str_in(1:leng)
	last = leng
	else
c	write(*,*) 'leng2, leng0, leng', leng2, leng0, leng
	string(1:leng2) = env_out(1:leng2)
c	write(*,*) '1', leng2+1, leng2+leng-leng0+1
c	write(*,*) '2', leng0, leng
	if (leng-leng0 .gt. 0 ) 
     * string(leng2+1:leng2+leng-leng0) = str_in(leng0+1:leng)
	last = leng2+leng-leng0
	end if
91	continue
c	write(*,*) 'file: ', string(1:last), ' : ', last
	if ( string(last:last) .ne. '/' ) then
	open ( unit = iu, file = string(1:last), status = 'old', 
     * err = 312 )
	close (unit = iu)
	end if
c	write(*,*) 'file opened OK'
	str_out(1:last) = string(1:last)
	iok = 0
	return
312	continue
	iok = 1
c	write(*,*) ' last', last
c	write(*,*) ' leng_env', leng_env
	if ( leng_env .gt. 0 .and. last .gt. 0 .and.
     * string_env(1:4) .eq. 'MAIN' ) 
     * write(*,*) ' %ERROR: file {', string(1:last), 
     * ' environment: {', string_env(1:leng_env), '} NOT FOUND'
	return
	end
