#!/bin/sh
#!perl  -w
eval 'exec perl -x $0 ${1+"$@"}'
    if 0;

use strict;

my %titles = ();
my %references = ();

while(<>) {
    chomp;
    my @line = split("<", $_, 2);
    my $key = lc($line[0]);
    $key =~ s/\s+|//g;
    $line[1] = "<" . $line[1];
    $titles{$key} = $line[0];
    push( @{$references{$key}}, $line[1] );
}

print <<EOT;
<html>
<head><title>Index</title></head>
<body>
<h1>Index</h1>
    <table border = 0 cellspacing = 10>
EOT

## use lib "$ENV{HOME}/lib/perl5";
## use ShowStruct;
## showRef(\%titles);
## showRef(\%references);

my $key;
foreach $key (sort keys %titles) {
    print <<"    EOT";
    <tr>
    <th align=left valign=top> $titles{$key} </th>
    <td>
    EOT
    foreach (@{$references{$key}}) {
        print "\t$_<br>\n";
    }
    print <<"    EOT";
    </td>
    </tr>
    EOT
}

print <<EOT;
</table>
Saulius Grazullis is acknowledged 
for writing the perl script for this keyword index generation.
</body>
</html>
EOT
