c
c  read a map
c
	program makemap
	parameter (nrmaps=6000000)
c	parameter (nbmaps=6000000)
	dimension  rmaps(nrmaps)
	character*80 line
	logical convert
c
	iu = 1
	ires = 2
	write(*,*) ' X-PLOR MAP FILE NAME:'
	read(*,99,err=100) (line(j:j),j=1,80)
	open ( unit = iu, file = line, shared, readonly,
     * status = 'old', err = 104 )
c xplorers map
1	continue
	read(iu,99,err=100) (line(j:j),j=1,80)
99	format( 80a1 )
	read(iu,99,err=100) (line(j:j),j=1,80)
	read( line(1:8), '(i8)' ) ilin
c title
	do 11 i = 1, ilin
	read(iu,99,err=100) (line(j:j),j=1,80)
11	continue
c number of points etc
	read(iu,99,err=100) (line(j:j),j=1,80)
	read(line(1:80), *, err=102) na, ia1, ia2, nb, ib1, ib2, 
     * nc, ic1, ic2
	ma = ia2 - ia1 + 1
	mb = ib2 - ib1 + 1
	mc = ic2 - ic1 + 1
	nmaps = ma * mb * mc
111	format( 9i5 )
	write(*,*) ' NUMBER OF GRID POINTS IN CELL', na, nb, nc
	write(*,*) ' INITIAL COORDINATES OF MAP IN GRID', ia1,ib1,ic1
	write(*,*) ' NUMBER OF GRID POINTS IN MAP', ma, mb, mc
	write (*,*) ' TOTAL NUMBER OF GRID POINTS:', nmaps
	if ( nmaps .gt. nrmaps ) goto 103
c cell constants
	read(iu,99,err=100) (line(j:j),j=1,80)
	read(line(1:80), 12, err=102) acell, bcell, ccell,
     * calpha, cbeta, cgama
12	format( 6e12.5 )
	read(iu,99,err=100) (line(j:j),j=1,80)
c	if ( line(2:3) .eq. 'XY' ) convert = .false.
c	if ( line(2:3) .eq. 'YX' ) convert = .true.
c	write(*,*) ' conv:', line(1:3), '  ', convert
	write(*,*) ' MAIN MAP FILE NAME:'
	read(*,99,err=100) (line(j:j),j=1,80)
	n = 0
	nm = ma * mb
	do 14 i = 1, mc
	if ( mod( nm, 6) .gt. 0 ) nlin = nlin + 1
	read(iu, *) izsect
	write(*,*) ' READING Z-SECTION', izsect
	read( iu, 12, end = 102, err = 101) (rmaps(n+j), j=1,nm)
	n = n + nm
14	continue
	close (unit=iu)
c  
	rmin =  99999999.9
	rmax = -99999999.9
	do 2 i = 1, nmaps
	if ( rmaps(i) .gt. rmax ) rmax = rmaps(i)
	if ( rmaps(i) .lt. rmin ) rmin = rmaps(i)
2	continue
	delta = ( rmax - rmin ) / 255
	write(*,*)  ' MINIMUM, MAXIMIM AND DIFFERENCE DENSITY ', 
     * rmin, rmax, delta
c
	open ( unit = ires, file = line, status = 'new',
     * carriagecontrol = 'list', err = 104 )
c
	write(ires,12) acell, bcell, ccell, calpha, cbeta, cgama
	write(ires, 111) na, nb, nc, ia1, ib1, ic1, ma, mb, mc 
	write(ires,12) rmin, rmax, delta
c	write(0,*) 'i, inte, del, del/delta, ichar(bmaps(i)), '
c	if ( convert ) then
c	write(*,*) ' ZXY conversion y-fast'
c	i5 = 0
c	do 31 iz = 1, mc
c	do 32 iy = 1, mb
c	do 33 ix = 1, ma
c	i4 = (iz-1) * nm + (iy-1)*ma + ix
c	i5 = i5 + 1
c	inte = ifix( ( rmaps(i4) - rmin ) / delta + 0.5)
c	bmaps(i5) = char(inte)
c	del = rmaps(i)-rmin
c	write(0,*) i, inte, del, del/delta, ichar(bmaps(i))
c	 indx2 = 0
c	 do inx=1,ngx
c	  do iny=1,ngy
c	   indx2 = indx2 + 1
c	   indx1 = ngx * (iny-1) + inx
c	   rho(indx2) = rhotmp(indx1)
c	  end do
c	 end do
c33	continue	
c32	continue	
c31	continue	
c	else
c	write(*,*) ' ZYX x-slow ?'
c	end if
	write(ires, 44, err=104) (rmaps(i), i=1, nmaps)
44	format(20a4)
	stop
100	write (*,*) ' RD_MAP> ERROR: READING MAP FILE TITLE '
	stop
101	write (*,*) ' RD_MAP> ERROR: READING MAP FILE '
	stop
102	write ( *,* ) ' RD_MAP> END OF FILE DETECTED'
	stop
103	write ( *,* ) ' RD_MAP> NUMBER OF GRID POINTS OVER BOUNDRIES'
	stop
104	write ( *,* ) ' WR_MAP> CREATING FILE FAILED'
	stop
	end
