subroutine char FILE char SEGM_FROM char SEGM_TO char SEQ_PAIRS \
           char SEGM_WORK real CUT_OFF char ROOT_DIR char PROT_OUT

dele atom sele .n orig end

read file FILE + .PDB coor pdb
read file FILE + .CTAB ctab first sele .n orig end
key from_fit sele segm name SEGM_FROM .a atom name CA .a \
    seq SEQ_PAIRS end
make pair init sele from_fit end sele to_fit end

key work sele segm name SEGM_WORK end 

rms coor all eigen pair 
rota atom sele work end rms
tran atom sele work end rms

!return

calc pair ( init sele segm name SEGM_FROM .a atom name CA end \
      sele segm name SEGM_TO .a atom name CA end range 0. CUT_OFF )

rms coor all eigen pair 
rota atom sele work end rms
tran atom sele work end rms


calc pair ( init sele segm name SEGM_FROM .a atom name CA end \
      sele segm name SEGM_TO .a atom name CA end range 0. CUT_OFF )

rms coor all eigen pair 
rota atom sele work end rms
tran atom sele work end rms

calc pair ( init sele segm name SEGM_FROM .a atom name CA end \
      sele segm name SEGM_TO .a atom name CA end range 0. CUT_OFF )

rms coor all eigen pair 
rota atom sele work end rms
tran atom sele work end rms

dele atom sele .n orig .a .n segm name SEGM_WORK end
dele atom sele atom name H* end
image group name gr_ + PROT_OUT
ima col 220 sele segm name SEGM_WORK end col 200 bond
ima col 220 sele segm name SEGM_WORK .a resi name HOH end col 200 atom cros


write over file ROOT_DIR + PROT_OUT + .pdb sele work end atom pdb
write over file ROOT_DIR + PROT_OUT + .ctab sele work end ctab \
	first sele work end 
return


subroutine char FILE_IN char NEW_SEGM \
	char S1 char S2 char S3 ! char S4 \
	char ORIG_SEGM \
	char PROT_OUT char PROT_CHAIN \
	char INH_OUT char INH_CHAIN

sho vari PROT_OUT
sho vari PROT_CHAIN
sho vari INH_CHAIN
!return

delet atom sele .not orig end

show segm
echo READ FILE_IN
read file FILE_IN + .PDB coor pdb 
read file FILE_IN + .CTAB ctab first sele .n orig end

dele atom sele atom name H* end

key x sele segm name NEW_SEGM end
make chain sele segm name NEW_SEGM end

!show chain

key from_fit sele segm name PROT_OUT .a atom name CA .a \
    seq S1 S2 S3  end

make pair init sele from_fit .a chain name PROT_CHAIN end sele to_fit end

key work sele segm name NEW_SEGM end 

<MAIN_UTILS:rms_fit_1_key_to_2_segm.com PROT_OUT work ORIG_SEGM CA 1.7 USE
<MAIN_UTILS:rms_fit_1_key_to_2_segm.com PROT_OUT work ORIG_SEGM CA 1.7 CALC


image group name group_ + PROT_OUT

write over file PROT_OUT + .pdb sele work end atom pdb
write over file PROT_OUT + .ctab sele work end ctab \
	first sele work end 
image col 220 sele work .a atom name C N CA end bond

key work sele chain name INH_CHAIN .a segm name NEW_SEGM end 
show key work
if ( IRESULT_0 .le. 0 ) return
write over file INH_OUT + .pdb sele work end atom pdb
write over file INH_OUT + .ctab sele work end ctab \
	first sele work end 
return


