subroutine int MAP_DENS int MAP_SOLV real SOLV_RAD 

! MAP_SCORE is the map used for the score map
! MAP_FROM contains electron density to be analysed - unit cell map
! SOLV_RAD is the radius for the solvent statistics

! Copy the MIR density into the new MAP_SOLV, set all negative density
! values to zero and Fourier transform it.  R-value calculation is

show vari MAP_DENS
show vari MAP_SOLV
show vari SOLV_RAD


make map MAP_SOLV from MAP_DENS init 9999 cell real
make map MAP_SOLV from MAP_DENS copy
!make map MAP_SOLV from MAP_DENS mult 
make map MAP_SOLV set -99999 0 0.0

fourier map MAP_SOLV

reflect sele WORK_REFL end shells 10 r-values 

set vari NEW_MAP = nmaps + 1
make map NEW_MAP from MAP_DENS init -9999  cell real
make atom from coor 0.0 0.0 0.0
make map NEW_MAP sele atom numb natom end atom dist SOLV_RAD line ! gaus
make map NEW_MAP set -99999 -100 0.0
dele atom sele atom numb natom end
fourier map NEW_MAP



make map MAP_SOLV from NEW_MAP mult
make map MAP_SOLV conj
dele map NEW_MAP

! refl move fcalc fwork
! refl sele defined .o asym end solv_flat SOLV_RAD 
! refl sele defined .o asym end set ampl phase fwork = fwork * 1.0 * fcalc * -1.0
! 
! make map MAP_SOLV zero
! refl fill-map MAP_SOLV select defined .o asymm end

four map MAP_SOLV back 
make map MAP_SOLV prescale 

return
