subroutine int MAP_DENS int MAP_SOLV real SOLV_RAD real SOLV_CUT 

! Copy the MIR density into the new MAP_SOLV, set all negative density
! values to zero and Fourier transform it.  R-value calculation is

make map MAP_SOLV from MAP_DENS init 9999 cell real
make map MAP_SOLV from MAP_DENS copy
make map MAP_SOLV set -99999 0 0.0
show map MAP_SOLV
fourier map MAP_SOLV

reflect sele WORK_REFL end shells 10 r-values 

set vari NEW_MAP = nmaps + 1
make map NEW_MAP from MAP_DENS init -9999  cell real
make atom from coor 0.0 0.0 0.0
make map NEW_MAP sele atom numb natom end atom dist SOLV_RAD linea
dele atom sele atom numb natom end
fourier map NEW_MAP

make map MAP_SOLV from NEW_MAP mult
dele map NEW_MAP

make map MAP_SOLV conj
four map MAP_SOLV back 
make map MAP_SOLV prescale 

! Perform the score map analyses (map occupancy in 256 steps)

anal ini
anal map MAP_SOLV step 256
make map MAP_SOLV anal range SOLV_CUT 

! 
! ! remove small lonely mask clouds and fill the holes 
! 
! make map MAP_SOLV + 1 from MAP_SOLV init 9999 copy
! make map MAP_SOLV from MAP_SOLV + 1 remove HOLE_SIZE
! make map MAP_SOLV + 1 from MAP_SOLV init 9999 copy
! make map MAP_SOLV from MAP_SOLV + 1 remove HOLE_SIZE
! make map MAP_SOLV + 1 from MAP_SOLV init 9999 copy
! make map MAP_SOLV from MAP_SOLV + 1 remove HOLE_SIZE
! make map MAP_SOLV + 1 from MAP_SOLV init 9999 copy
! make map MAP_SOLV from MAP_SOLV + 1 remove HOLE_SIZE
! 
! make map MAP_SOLV + 1 from MAP_SOLV init 9999 copy
! make map MAP_SOLV from MAP_SOLV + 1 fill HOLE_SIZE
! make map MAP_SOLV + 1 from MAP_SOLV init 9999 copy
! make map MAP_SOLV from MAP_SOLV + 1 fill HOLE_SIZE
! 

! Convert the selected parts to a MASK region and copy density into it.
! Set the density of the empty region to, Fourier transform it and
! caluclate R-values.

make map MAP_SOLV from MAP_DENS copy
return

make map MAP_SOLV set -99999 -9000 0.0
fourier map MAP_SOLV
reflect shells 10 r-values 

! Save the FCALCULATE values in the FWORKSET array and calculate
! an Fobs map 

reflect set ampl phase fwork = fcalc * 1.0
reflect set ampl fwork = fobs * 1.0

! or 2 Fobs - Fcalc map.

! reflect set ampl scale fcalc fwork = fobs * 2.0 - fcalc * 1.0

return


