subroutine int MAP_FROM int MAP_TO int MAP_SCORE \
	real SOLV_RAD 


! MAP_SCORE is the map used for the score map
! MAP_FROM contains electron density to be analysed - unit cell map
! MAP_TO   contains the resulting solvent flattened map - a unit cell map
! SOLV_RAD is the radius for the solvent statistics
! SOLV_CUT is the content of the solvent region that is to be flattened
! GAMMA is the flipping factor should have negative sign
!       (vol protein) / (vol solvent) 


make map MAP_SCORE from MAP_FROM init 9999 real

! if you know how, you can make the MAP_SCORE 
! to incompass only the asymmetric unit:
! make map MAP_SCORE from MAP_FROM init 9999 box 0 0 0 30 40 50


make map MAP_SCORE from MAP_FROM cut 0.0 radi SOLV_RAD \
        rms linear
anal ini
anal map MAP_SCORE step 256
show anal
! it makes sense at least for the first time to look at a possible envelope
! on a display, therefore return 
return
